CLASS-POOL.
*---------------------------------------------------------------------*
*       CLASS ZCL_ES_GUI_ABAP_EDITOR  DEFINITIO
*---------------------------------------------------------------------*
*
*---------------------------------------------------------------------*
CLASS zcl_es_gui_abap_editor DEFINITION
  PUBLIC
  INHERITING FROM cl_gui_control
  CREATE PUBLIC.

  PUBLIC SECTION.
* Only for comparing     TYPE-POOLS cndp.
* Only for comparing     TYPE-POOLS seoo.
* Only for comparing     TYPE-POOLS seos.
* Only for comparing     TYPE-POOLS swbse.

    TYPES bookmark_tbl TYPE zes_bookmark_tbl.
    TYPES breakpoint_tbl TYPE zes_breakpoint_tbl.
    TYPES point TYPE zes_point.
    TYPES protected_lines_tbl TYPE zes_protected_lines_tbl.

    CONSTANTS cmd_print TYPE i VALUE 57607.                 
    CONSTANTS cnst_brs_fixed_single TYPE int2 VALUE 1.      
    CONSTANTS cnst_brs_none TYPE int2 VALUE 0.              
    CONSTANTS cnst_bs_opaque TYPE int2 VALUE 1.             
    CONSTANTS cnst_bs_transparent TYPE int2 VALUE 0.        
    CONSTANTS cnst_false TYPE boolean VALUE 0.              
    CONSTANTS cnst_text_centered TYPE int2 VALUE 2.         
    CONSTANTS cnst_text_left TYPE int2 VALUE 0.             
    CONSTANTS cnst_text_right TYPE int2 VALUE 1.            
    CONSTANTS cnst_true TYPE boolean VALUE 1.               

    EVENTS completion
      EXPORTING
        value(iv_context_string) TYPE string
        value(iv_pos) TYPE point.
    EVENTS help
      EXPORTING
        value(iv_context_string) TYPE string
        value(iv_current_word) TYPE string
        value(iv_pos) TYPE point.
    EVENTS insert_pattern
      EXPORTING
        value(iv_data_type) TYPE int4
        value(iv_pattern_key) TYPE string
        value(iv_pos) TYPE point.
    EVENTS navigate
      EXPORTING
        value(iv_context_string) TYPE string
        value(iv_current_word) TYPE string
        value(iv_pos) TYPE point.
    EVENTS quick_info
      EXPORTING
        value(iv_context_string) TYPE string
        value(iv_data_type) TYPE int4
        value(iv_pos) TYPE point.

    METHODS add_empty_doc
      IMPORTING
        !str_name TYPE string
        !b_readonly TYPE i DEFAULT cfalse
        !str_extension TYPE string DEFAULT 'ABAP'
        !str_tooltip TYPE string DEFAULT 'Test'
      EXCEPTIONS
        unable_to_set_doc.
    METHODS constructor
      IMPORTING
        value(style) TYPE i DEFAULT 0
        value(parent) TYPE REF TO cl_gui_container
        value(lifetime) TYPE i OPTIONAL
        value(name) TYPE string OPTIONAL
        !report_name TYPE syrepid OPTIONAL
      EXCEPTIONS
        error_cntl_create
        error_cntl_init
        error_cntl_link
        error_dp_create
        gui_type_not_supported.
    METHODS get_bookmarks_as_r3table
      EXPORTING
        !et_bookmarks TYPE bookmark_tbl
      EXCEPTIONS
        error_dp.
    METHODS get_breakpoints_as_r3table
      EXPORTING
        !et_breakpoints TYPE breakpoint_tbl
      EXCEPTIONS
        error_dp.
    METHODS get_protected_lines_as_r3table
      EXPORTING
        !et_plines TYPE protected_lines_tbl
      EXCEPTIONS
        error_dp.
    METHODS load
      IMPORTING
        !report_name TYPE syrepid.
    METHODS on_command_execute
      IMPORTING
        value(i_command) TYPE int4.
    METHODS on_completion
      IMPORTING
        !iv_context_string TYPE string
        !iv_pos TYPE point
      EXCEPTIONS
        error_dp.
    METHODS on_help
      IMPORTING
        !iv_context_string TYPE string
        !iv_current_word TYPE string
        !iv_pos TYPE point.
    METHODS on_insert_pattern
      IMPORTING
        !iv_pattern_key TYPE string
        !iv_pos TYPE point
        !iv_data_type TYPE int4
      EXCEPTIONS
        error.
    METHODS on_navigate
      IMPORTING
        !iv_context_string TYPE string
        !iv_current_word TYPE string
        !iv_pos TYPE point.
    METHODS on_quick_info
      IMPORTING
        !iv_context_string TYPE string
        !iv_pos TYPE point
        !iv_data_type TYPE int4
      EXCEPTIONS
        error.
    METHODS register_events.
    METHODS save
      IMPORTING
        !report_name TYPE syrepid OPTIONAL.
    METHODS set_bookmarks_as_r3table
      IMPORTING
        !it_bookmarks TYPE bookmark_tbl
      EXCEPTIONS
        error_dp.
    METHODS set_breakpoints_as_r3table
      IMPORTING
        !it_breakpoints TYPE breakpoint_tbl
      EXCEPTIONS
        error_dp.
    METHODS set_protected_lines_as_r3table
      IMPORTING
        !it_plines TYPE protected_lines_tbl
      EXCEPTIONS
        error_dp.
    METHODS set_readonly_mode
      IMPORTING
        !readonly_mode TYPE boolean DEFAULT 'X'.
    METHODS update_display.

    METHODS dispatch
      REDEFINITION.
    METHODS free
      REDEFINITION.
* Only for comparing     TYPE-POOLS cntl.
  PROTECTED SECTION.

    TYPES bool TYPE int4.
    TYPES:
      BEGIN OF comp_dict_str,
        data_type      TYPE int4,
        image_indx     TYPE int4,
        sub_image_indx TYPE int4,
        bold           TYPE int4,
        tlength        TYPE int4,
        text           TYPE char255,
      END OF comp_dict_str.
    TYPES:
      comp_dict_tbl TYPE TABLE OF comp_dict_str.
    TYPES:
      my_string(256) TYPE c.
    TYPES report2_tbl TYPE rswsourcet.
    TYPES:
      report_tbl  TYPE STANDARD TABLE OF char255.
    TYPES:
      BEGIN OF source_str,
        include TYPE include,
        line    TYPE string,
      END OF source_str.
    TYPES:
      source_tbl TYPE TABLE OF source_str.
    TYPES:
      words_tbl  TYPE TABLE OF string.

    CONSTANTS gc_false TYPE c VALUE space.                  
    CONSTANTS gc_true TYPE c VALUE 'X'.                     
    DATA gt_attributes TYPE seoo_attributes_r.
    DATA gt_bookmarks TYPE bookmark_tbl.
    DATA gt_breapoints TYPE breakpoint_tbl.
    DATA:
      gt_compo         TYPE TABLE OF scompo.
    DATA:
      gt_cross_ref     TYPE TABLE OF cross.
    DATA:
      gt_inc           TYPE TABLE OF d010inc.
    DATA:
      gt_messages      TYPE TABLE OF t100.
    DATA gt_methods TYPE seoo_methods_r.
    DATA:
      gt_nametab       TYPE TABLE OF dfies.
    DATA:
      gt_progdir       TYPE TABLE OF progdir.
    DATA gt_protec_lines TYPE protected_lines_tbl.
    DATA gt_sources TYPE source_tbl.
    DATA:
      gt_textpool      TYPE TABLE OF textpool.
    DATA gv_main_prog LIKE sy-repid.
    DATA gv_new_rdire TYPE trdire.
    DATA gv_report_name LIKE sy-repid.
    CONSTANTS mc_ext_attribute TYPE char2 VALUE 'LD'.       
    CONSTANTS mc_ext_method TYPE char2 VALUE 'LM'.          
    CONSTANTS mc_translate_ids TYPE char64
 VALUE ' D T 9FU LY E SIKMO  A  Q  1'.
    CONSTANTS mc_wt_all TYPE i VALUE 0.                     
    CONSTANTS mc_wt_attribute_all TYPE i VALUE 100.         
    CONSTANTS mc_wt_attrib_class TYPE i VALUE 25.           
    CONSTANTS mc_wt_attrib_instance TYPE i VALUE 26.        
    CONSTANTS mc_wt_authority_check TYPE i VALUE 27.        
    CONSTANTS mc_wt_dict_any_type TYPE i VALUE 28.          
    CONSTANTS mc_wt_dict_data_elem TYPE i VALUE 20.         
    CONSTANTS mc_wt_dict_structure TYPE i VALUE 21.         
    CONSTANTS mc_wt_dict_table_type TYPE i VALUE 22.        
    CONSTANTS mc_wt_domain_values TYPE i VALUE 11.          
    CONSTANTS mc_wt_fieldsymbol TYPE i VALUE 13.            
    CONSTANTS mc_wt_form TYPE i VALUE 7.                    
    CONSTANTS mc_wt_function TYPE i VALUE 6.                
    CONSTANTS mc_wt_include TYPE i VALUE 15.                
    CONSTANTS mc_wt_macro TYPE i VALUE 16.                  
    CONSTANTS mc_wt_message TYPE i VALUE 24.                
    CONSTANTS mc_wt_method_all TYPE i VALUE 101.            
    CONSTANTS mc_wt_method_class TYPE i VALUE 4.            
    CONSTANTS mc_wt_method_instance TYPE i VALUE 5.         
    CONSTANTS mc_wt_module TYPE i VALUE 19.                 
    CONSTANTS mc_wt_module_i TYPE i VALUE 17.               
    CONSTANTS mc_wt_module_o TYPE i VALUE 18.               
    CONSTANTS mc_wt_object TYPE i VALUE 9.                  
    CONSTANTS mc_wt_screen TYPE i VALUE 14.                 
    CONSTANTS mc_wt_structure_field TYPE i VALUE 2.         
    CONSTANTS mc_wt_table TYPE i VALUE 8.                   
    CONSTANTS mc_wt_text_element TYPE i VALUE 12.           
    CONSTANTS mc_wt_transaction TYPE i VALUE 3.             
    CONSTANTS mc_wt_type TYPE i VALUE 10.                   
    CONSTANTS mc_wt_type_pool TYPE i VALUE 23.              
    CONSTANTS mc_wt_variable TYPE i VALUE 1.                
    CONSTANTS mimesubtype TYPE my_string VALUE 'X-R3ABAP'.  
    CONSTANTS mimetype TYPE my_string VALUE 'APPLICATION'.  

    METHODS analyze_context
      IMPORTING
        !iv_context_string TYPE string
        !iv_pos TYPE i
      EXPORTING
        !ev_data_type TYPE int4
        !ev_def_start TYPE i
        !ev_parent TYPE string
        !ev_pattern TYPE string.
    METHODS convert_types
      IMPORTING
        !iv_ext_type TYPE char2 OPTIONAL
        !iv_int_type TYPE int4 OPTIONAL
      EXPORTING
        !ev_ext_type TYPE char2
        !ev_int_type TYPE int4.
    METHODS delete_text
      IMPORTING
        !is_start TYPE point
        !is_end TYPE point.
    METHODS get_attribute_quick_info
      IMPORTING
        !iv_class_name TYPE string
        !iv_attrib_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_class_quick_info
      IMPORTING
        !iv_class_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_data_elem_quick_info
      IMPORTING
        !iv_data_elem_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_dict_any_type_quick_info
      IMPORTING
        !iv_dict_any_type TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_dict_structure_quick_info
      IMPORTING
        !iv_dict_structure TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_form_pattern
      IMPORTING
        !iv_pattern_key TYPE string
      EXPORTING
        !et_pattern TYPE STANDARD TABLE
      EXCEPTIONS
        not_found.
    METHODS get_function_pattern
      IMPORTING
        !iv_pattern_key TYPE string
      EXPORTING
        !et_pattern TYPE STANDARD TABLE
      EXCEPTIONS
        not_found.
    METHODS get_function_quick_info
      IMPORTING
        !iv_function_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_message_pattern
      IMPORTING
        !iv_pattern_key TYPE string
      EXPORTING
        !et_pattern TYPE STANDARD TABLE
      EXCEPTIONS
        not_found.
    METHODS get_message_quick_info
      IMPORTING
        !iv_message TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_method_pattern
      IMPORTING
        !iv_instance TYPE string
        !iv_class_name TYPE string
        !iv_pattern_key TYPE string
      EXPORTING
        !et_pattern TYPE STANDARD TABLE
      EXCEPTIONS
        not_found.
    METHODS get_method_quick_info
      IMPORTING
        !iv_class_name TYPE string
        !iv_method_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_report
      EXPORTING
        !et_report TYPE report_tbl.
    METHODS get_selected_text_as_r3table
      EXPORTING
        !table TYPE STANDARD TABLE
      EXCEPTIONS
        error_dp.
    METHODS get_struct_comp_quick_info
      IMPORTING
        !iv_str_comp_name TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_table_type_quick_info
      IMPORTING
        !iv_table_type TYPE string
      EXPORTING
        !ev_row_type TYPE string
        !ev_quick_info TYPE string
      EXCEPTIONS
        not_found.
    METHODS get_text_as_r3table
      IMPORTING
        !only_when_modified TYPE i DEFAULT cfalse
      EXPORTING
        !table TYPE STANDARD TABLE
        !is_modified TYPE i
      EXCEPTIONS
        error_dp.
    METHODS get_text_element_pattern
      IMPORTING
        !iv_pattern_key TYPE string
      EXPORTING
        !et_pattern TYPE STANDARD TABLE
      EXCEPTIONS
        not_found.
    METHODS get_text_element_quick_info
      IMPORTING
        !iv_text_elem TYPE string
      EXPORTING
        !ev_quick_info TYPE string.
    METHODS get_type
      IMPORTING
        !iv_rep_name LIKE sy-repid
        !iv_line TYPE string
        !iv_definition TYPE string
        !iv_row_str TYPE boolean OPTIONAL
        !is_def_pos TYPE point
      EXPORTING
        !ev_type_name TYPE string
        !ev_comp_name TYPE string
      EXCEPTIONS
        not_found.
    METHODS get_type_by_object
      IMPORTING
        !iv_pos TYPE point
        !iv_rep_name LIKE sy-repid OPTIONAL
        !iv_row_str TYPE boolean OPTIONAL
      EXPORTING
        !ev_type_id TYPE int4
        !ev_object_name TYPE string
        !ev_instance_def TYPE string
        !ev_type_name TYPE string
        !ev_parent TYPE string
      EXCEPTIONS
        not_found.
    METHODS is_dictionary_type
      IMPORTING
        !iv_dict_any_type TYPE string
      EXPORTING
        !ev_type TYPE int4.
    METHODS prepare_class_attributes_list
      IMPORTING
        !iv_data_type TYPE int4 OPTIONAL
        !iv_parent TYPE string
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL
      EXCEPTIONS
        not_found.
    METHODS prepare_class_methods_list
      IMPORTING
        !iv_data_type TYPE int4 OPTIONAL
        !iv_parent TYPE string
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL
      EXCEPTIONS
        not_found.
    METHODS prepare_dict_class_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_dict_data_elem_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_dict_structure_list
      IMPORTING
        !iv_data_type TYPE int4
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_dict_table_type_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_domain_values_list
      IMPORTING
        !iv_parent TYPE string
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL
      EXCEPTIONS
        not_found.
    METHODS prepare_dynpro_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_function_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_message_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL.
    METHODS prepare_program_index_list
      IMPORTING
        !iv_data_type TYPE int4
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_struct_component_list
      IMPORTING
        !iv_parent TYPE string
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL
      EXCEPTIONS
        not_found.
    METHODS prepare_text_element_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl OPTIONAL.
    METHODS prepare_transaction_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS prepare_type_pool_list
      IMPORTING
        !iv_pattern TYPE string
      CHANGING
        !ct_list TYPE comp_dict_tbl.
    METHODS read_report
      IMPORTING
        !iv_report_name LIKE sy-repid
      EXPORTING
        !et_report TYPE report_tbl.
    METHODS refresh_buffers.
    METHODS set_selected_text_as_r3table
      IMPORTING
        !table TYPE STANDARD TABLE
      EXCEPTIONS
        error_dp.
    METHODS set_text_as_r3table
      IMPORTING
        !table TYPE STANDARD TABLE
      EXCEPTIONS
        error_dp.
    METHODS update_structure.
  PRIVATE SECTION.

    CONSTANTS event_completion TYPE i VALUE 11.             
    CONSTANTS event_help TYPE i VALUE 3.                    
    CONSTANTS event_insert_pattern TYPE i VALUE 13.         
    CONSTANTS event_navigate TYPE i VALUE 1.                
    CONSTANTS event_quick_info TYPE i VALUE 12.             
    CONSTANTS event_save TYPE i VALUE 10.                   
    CONSTANTS event_settings_updated TYPE i VALUE 15.       
    DATA gs_end TYPE point.
    DATA gs_start TYPE point.
    DATA gv_parent TYPE string.
    DATA gv_struct_update TYPE boolean.
    DATA gv_version TYPE int4.
    DATA h_table TYPE cntl_handle.
    DATA m_dp_handle TYPE cntl_handle.
ENDCLASS.                    "ZCL_ES_GUI_ABAP_EDITOR  DEFINITIO
*---------------------------------------------------------------------*
*                       REDIFINITIONS
*---------------------------------------------------------------------*
*
*                                                                     *
*---------------------------------------------------------------------*
*                       IMPLEMENTATION
*---------------------------------------------------------------------*
*
*                                                                     *
METHOD add_empty_doc.
*@78\QImporting@	STR_NAME	TYPE STRING	
*@78\QImporting@	B_READONLY	TYPE I  DEFAULT CFALSE	Boolean Variable (X=True, -=False, Space=Unknown)
*@78\QImporting@	STR_EXTENSION	TYPE STRING  DEFAULT 'ABAP'	
*@78\QImporting@	STR_TOOLTIP	TYPE STRING  DEFAULT 'Test'	
*@03\QException@	UNABLE_TO_SET_DOC		Font Set Error

  CALL METHOD call_method
    EXPORTING
      method            = 'AddEmptyDoc'
      p_count           = 4
      p1                = str_name
      p2                = b_readonly
      p3                = str_extension
      p4                = str_tooltip
    EXCEPTIONS
      cntl_system_error = 1
      cntl_error        = 2
      OTHERS            = 3.
  IF sy-subrc <> 0.
    RAISE unable_to_set_doc.
  ENDIF.

ENDMETHOD.                    "ADD_EMPTY_DOC
METHOD analyze_context.
  DATA: lt_words     TYPE words_tbl,
          lv_string    TYPE string,
          lv_word      TYPE string,
          lv_method    TYPE i,
          lv_attribute TYPE i,
          lv_words_num TYPE i,
          lv_replace   TYPE c,
          lv_num       TYPE i.

  FIELD-SYMBOLS: <ls_word>  LIKE LINE OF lt_words.

* Initialyze datatype and pattern by default value
  ev_data_type = mc_wt_all.
  ev_pattern   = '%'.
  ev_parent    = space.
  ev_def_start = iv_pos.

* If context string is empty, return that we need all available data
  CHECK NOT iv_context_string IS INITIAL.

  lv_string   = iv_context_string(iv_pos).

* Replace not translated characters
  replace_all_occurrences cl_abap_char_utilities=>horizontal_tab '.' lv_string.
  TRANSLATE lv_string USING ': , . '.

* Prepare class methods / atrributes calls
  replace_all_occurrences '=>' ' ~~> ' lv_string.
  replace_all_occurrences '->' ' ~> '  lv_string.

* Prepare structure components complition
  replace_all_occurrences '-' ' ~ '  lv_string.

* Because ABAP not case sensitive - convert all to upper case
  TRANSLATE lv_string TO UPPER CASE.

* Split context string to separate words by space
  SPLIT lv_string AT space INTO TABLE lt_words.

* Organize table with words
  LOOP AT lt_words ASSIGNING <ls_word>.
    CONDENSE <ls_word> NO-GAPS.
    CHECK <ls_word> IS INITIAL.
    DELETE lt_words.
  ENDLOOP.

  DESCRIBE TABLE lt_words LINES lv_words_num.

* Check for existing context
  CHECK lv_words_num GT 0.

  lv_num = lv_words_num.

  WHILE lv_num GT 0.
    READ TABLE lt_words INDEX lv_num INTO lv_word.

* Check word
    CASE lv_word.
* Skip 'TO' like rather general
      WHEN 'TO'.
        lv_num = lv_num - 1.
        CONTINUE.
      WHEN '~~>' OR '~>'.
*         Store instance or method
        IF lv_word EQ '~~>'.
          lv_method    = mc_wt_method_class.
          lv_attribute = mc_wt_attrib_class.
        ELSE.
          lv_method    = mc_wt_method_instance.
          lv_attribute = mc_wt_attrib_instance.
        ENDIF.

*         Get Class name
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        CHECK sy-subrc EQ 0.
        ev_parent    = lv_word.

*         Analyze attribute or method
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        IF sy-subrc EQ 0 AND lv_word EQ 'METHOD'.
          lv_num = lv_num - 1.
          READ TABLE lt_words INDEX lv_num INTO lv_word.
          ev_data_type = lv_method.
        ELSE.
          lv_num = lv_num + 1.
          READ TABLE lt_words INDEX lv_num INTO lv_word.
          ev_data_type = lv_attribute.
        ENDIF.
      WHEN '~'.
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        CHECK sy-subrc EQ 0.
        IF lv_word EQ 'TEXT'.
          ev_data_type = mc_wt_text_element.
        ELSE.
          ev_parent    = lv_word.
          ev_data_type = mc_wt_structure_field.
        ENDIF.
      WHEN '='.
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        CHECK sy-subrc EQ 0.
        ev_parent    = lv_word.
        ev_data_type = mc_wt_domain_values.
      WHEN 'FUNCTION'.
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        CHECK sy-subrc EQ 0 AND lv_word EQ 'CALL'.
        ev_data_type = mc_wt_function.
      WHEN 'PERFORM'.
        ev_data_type = mc_wt_form.
      WHEN 'MODULE'.
        ev_data_type = mc_wt_module.
      WHEN 'SCREEN'.
        ev_data_type = mc_wt_screen.
      WHEN 'TRANSACTION'.
        ev_data_type = mc_wt_transaction.
      WHEN 'MESSAGE'.
        ev_data_type = mc_wt_message.
      WHEN 'TYPE'.
        ev_data_type = mc_wt_type.
      WHEN 'REF'.
        lv_num = lv_num - 1.
        READ TABLE lt_words INDEX lv_num INTO lv_word.
        CHECK sy-subrc EQ 0 AND lv_word EQ 'TYPE'.
        ev_data_type = mc_wt_object.
      WHEN 'LIKE'.
        ev_data_type = mc_wt_variable.
      WHEN 'INCLUDE'.
        ev_data_type = mc_wt_include.
* Only for comparing       WHEN 'TYPE-POOLS'.
        ev_data_type = mc_wt_type_pool.
      WHEN 'ASSIGNING'.
        ev_data_type = mc_wt_fieldsymbol.
      WHEN 'TABLE' OR 'TABLES'.
        ev_data_type = mc_wt_table.
      WHEN 'FROM'.
        READ TABLE lt_words WITH KEY table_line = 'SELECT'
        TRANSPORTING NO FIELDS.
        IF sy-subrc EQ 0 AND
           sy-tabix LT lv_num.
          ev_data_type = mc_wt_table.
        ENDIF.
      WHEN OTHERS.
* Decrease current word index
        lv_num = lv_num - 1.
        IF ev_pattern EQ '%'.
          ev_pattern = lv_word.
        ENDIF.
        CONTINUE.
    ENDCASE.

* Find start of definition
    IF lv_word NE 'CALL'    AND
       lv_word NE 'PERFORM'.
      lv_word = ev_pattern.
    ENDIF.

    IF lv_word NE '%'.
      CONCATENATE '.' lv_word '.' INTO lv_word SEPARATED BY space.
      CONCATENATE lv_string space INTO lv_string SEPARATED BY space.
      SEARCH lv_string FOR lv_word.
      IF sy-subrc EQ 0.
        ev_def_start = sy-fdpos + 1.
      ENDIF.
    ENDIF.

*     Prepare SQL pattern from ABAP pattern
    TRANSLATE ev_pattern USING '*%?_'.

*     Check always for pattern
    CONCATENATE ev_pattern '%' INTO ev_pattern.

*     In case if it is already requested with pattern replace duplicates
    REPLACE '%%' WITH '%' INTO ev_pattern.

*     If we already analyze context - exit
    EXIT.

  ENDWHILE.

ENDMETHOD.                    "analyze_context
METHOD constructor.
*@78\QImporting@	VALUE( STYLE )	TYPE I  DEFAULT 0	control style, if INITIAL a defined value is choosen
*@78\QImporting@	VALUE( PARENT )	TYPE REF TO CL_GUI_CONTAINER	Parent Container
*@78\QImporting@	VALUE( LIFETIME )	TYPE I
 OPTIONAL	for life time management
*@78\QImporting@	VALUE( NAME )	TYPE STRING
 OPTIONAL	name for the control
*@78\QImporting@	REPORT_NAME	TYPE SYREPID
 OPTIONAL	ABAP Program: Current Main Program
*@03\QException@	ERROR_CNTL_CREATE		Error Creating Control
*@03\QException@	ERROR_CNTL_INIT		Error Initializing Control
*@03\QException@	ERROR_CNTL_LINK		Error Linking Control
*@03\QException@	ERROR_DP_CREATE		DataProvider Error
*@03\QException@	GUI_TYPE_NOT_SUPPORTED		This type of GUI is not supported!


  DATA prog_id(80).

  IF parent IS INITIAL.
    RAISE error_cntl_create.
  ENDIF.

* Only for comparing   CLASS cl_gui_cfw DEFINITION LOAD.

* assign prog_id to get the frontend specific control
  IF NOT activex IS INITIAL.
    prog_id = 'SAPGUI.AbapEditor.1'.
  ELSEIF NOT javabean IS INITIAL.
    RAISE gui_type_not_supported.
  ENDIF.

  IF prog_id IS INITIAL.
    RAISE gui_type_not_supported.
  ENDIF.

* Set the window styles of the control when style parameter was not
* set with constructor call.
* For more information on the styles see WIN32 SDK
  IF style IS INITIAL.
* otherwise the control would be invisible and the mistake would be
* hard to find
    style = cl_gui_control=>ws_visible
            + cl_gui_control=>ws_child
            + cl_gui_control=>ws_clipsiblings.

  ENDIF.

* Create the control
  CALL METHOD super->constructor
    EXPORTING
      clsid      = prog_id
      shellstyle = style
      parent     = parent
      lifetime   = lifetime
      name       = name
    EXCEPTIONS
      OTHERS     = 1.

  CALL METHOD cl_gui_cfw=>flush
    EXCEPTIONS
      cntl_system_error = 1
      cntl_error        = 2
      OTHERS            = 3.

  IF sy-subrc <> 0.
    RAISE error_cntl_create.
  ENDIF.

* register instance at framework
  CALL METHOD cl_gui_cfw=>subscribe
    EXPORTING
      shellid = h_control-shellid
      ref     = me
    EXCEPTIONS
      OTHERS  = 1.

  IF sy-subrc <> 0.
    RAISE error_cntl_create.
  ENDIF.

* create and INITIALize dataprovider =>  m_dp_handle
  CALL FUNCTION 'DP_CREATE'
    CHANGING
      h_dp             = m_dp_handle
    EXCEPTIONS
      dp_create_error  = 1
      dp_install_error = 2
      dp_error         = 3
      OTHERS           = 4.
  IF sy-subrc <> 0.
    RAISE error_dp_create.
  ENDIF.

*   Register control events
  CALL METHOD register_events.

*   Enable control events
  CALL METHOD call_method
    EXPORTING
      method  = 'SubscribeOnCommand'
      p1      = 37311
      p2      = cfalse
      p_count = 2
    EXCEPTIONS
      OTHERS  = 1.

*  CALL METHOD set_property
*    EXPORTING
*      property = 'bNavigateOnDblClick'
*      value    = ctrue.
*
**   Set default language to ABAP
*  CALL METHOD set_property
*    EXPORTING
*      property = 'sProgLanguage'
*      value    = 'ABAP4'.

*   If report name provided - load it
  CHECK NOT report_name IS INITIAL.

  CALL METHOD load
    EXPORTING
      report_name = report_name.


ENDMETHOD.                    "constructor
METHOD convert_types.
*   Set default values
  ev_ext_type = iv_ext_type.
  ev_int_type = iv_int_type.

*   External to internal
  IF ev_ext_type IS REQUESTED AND iv_int_type IS SUPPLIED.
    ev_ext_type = mc_translate_ids+iv_int_type.

*   Some "SpeciaL" stuff
    IF ev_ext_type IS INITIAL.
      CASE iv_int_type.
        WHEN mc_wt_attribute_all.
          ev_ext_type = mc_ext_attribute.
        WHEN mc_wt_method_all.
          ev_ext_type = mc_ext_method.
      ENDCASE.
    ENDIF.
  ENDIF.

*   Internal to external
  IF ev_int_type IS REQUESTED AND iv_ext_type IS SUPPLIED.
    SEARCH mc_translate_ids FOR iv_ext_type.
    IF sy-subrc EQ 0.
      ev_int_type = sy-fdpos.
    ELSE.
*   Some "SpeciaL" stuff
      CASE iv_ext_type.
        WHEN mc_ext_attribute.
          ev_int_type = mc_wt_attribute_all.
        WHEN mc_ext_method.
          ev_int_type = mc_wt_method_all.
      ENDCASE.
    ENDIF.
  ENDIF.

ENDMETHOD.                    "convert_types
METHOD delete_text.
ENDMETHOD.                    "DELETE_TEXT
METHOD dispatch.
  DATA: lv_counter        TYPE i VALUE 0,
            lv_data_type      TYPE int4,
            lv_current_word   TYPE string,
            lv_context_string TYPE string,
            lv_pattern_key    TYPE string,
            lv_pos            TYPE point.

  CASE eventid.

*******************************************************************

    WHEN  event_navigate.

      get_event_parameter lv_context_string.
      get_event_parameter lv_current_word.
      get_event_parameter lv_pos-ypos.
      get_event_parameter lv_pos-xpos.
      make_flush.

      RAISE EVENT navigate
        EXPORTING
          iv_context_string   = lv_context_string
          iv_current_word     = lv_current_word
          iv_pos              = lv_pos.

      CALL METHOD on_navigate
        EXPORTING
          iv_context_string = lv_context_string
          iv_current_word   = lv_current_word
          iv_pos            = lv_pos.

*******************************************************************

    WHEN  event_help.

      get_event_parameter lv_context_string.
      get_event_parameter lv_current_word.
      get_event_parameter lv_pos-ypos.
      get_event_parameter lv_pos-xpos.
      make_flush.

      RAISE EVENT help
        EXPORTING
          iv_context_string   = lv_context_string
          iv_current_word     = lv_current_word
          iv_pos              = lv_pos.

      CALL METHOD on_help
        EXPORTING
          iv_context_string = lv_context_string
          iv_current_word   = lv_current_word
          iv_pos            = lv_pos.

*******************************************************************

    WHEN  event_save.
      CALL METHOD save.

*******************************************************************

    WHEN  event_completion.

      get_event_parameter lv_context_string.
      get_event_parameter lv_pos-ypos.
      get_event_parameter lv_pos-xpos.
      make_flush.

      RAISE EVENT completion
        EXPORTING
          iv_context_string   = lv_context_string
          iv_pos              = lv_pos.

      CALL METHOD on_completion
        EXPORTING
          iv_context_string = lv_context_string
          iv_pos            = lv_pos.

*******************************************************************

    WHEN  event_quick_info.

      get_event_parameter lv_context_string.
      get_event_parameter lv_pos-ypos.
      get_event_parameter lv_pos-xpos.
      get_event_parameter lv_data_type.
      make_flush.

*       Adopt vertical position to start from 1
      ADD 1 TO lv_pos-ypos.

      RAISE EVENT quick_info
        EXPORTING
          iv_context_string   = lv_context_string
          iv_pos              = lv_pos
          iv_data_type        = lv_data_type.

      CALL METHOD on_quick_info
        EXPORTING
          iv_context_string = lv_context_string
          iv_pos            = lv_pos
          iv_data_type      = lv_data_type.

*******************************************************************

    WHEN  event_insert_pattern.

      get_event_parameter lv_pattern_key.
      get_event_parameter lv_pos-ypos.
      get_event_parameter lv_pos-xpos.
      get_event_parameter lv_data_type.
      make_flush.

      RAISE EVENT insert_pattern
        EXPORTING
          iv_pattern_key    = lv_pattern_key
          iv_pos            = lv_pos
          iv_data_type      = lv_data_type.

      CALL METHOD on_insert_pattern
        EXPORTING
          iv_pattern_key = lv_pattern_key
          iv_pos         = lv_pos
          iv_data_type   = lv_data_type.

    WHEN OTHERS.
      RAISE cntl_error.

  ENDCASE.

ENDMETHOD.                    "dispatch
METHOD free.
* Check Object
  CHECK h_control IS INITIAL.

  CALL METHOD super->free.

* in addition to base class method: free data provider
  CALL FUNCTION 'DP_DESTROY'
    CHANGING
      h_dp             = m_dp_handle
    EXCEPTIONS
      dp_error_destroy = 1
      OTHERS           = 2.

  IF sy-subrc <> 0.
    RAISE cntl_error.
  ENDIF.

  CLEAR m_dp_handle.

ENDMETHOD.                    "free
METHOD get_attribute_quick_info.
  DATA: lv_decltyp       TYPE string,
            lv_typetxt       TYPE string.

  FIELD-SYMBOLS: <ls_attributes> LIKE LINE OF gt_attributes.

  IF gt_attributes IS INITIAL.
    CALL METHOD prepare_class_attributes_list
      EXPORTING
        iv_parent  = iv_class_name
        iv_pattern = '%'
      EXCEPTIONS
        OTHERS     = 1.
  ENDIF.

  READ TABLE gt_attributes WITH KEY cmpname = iv_attrib_name
  ASSIGNING <ls_attributes>.
  CHECK sy-subrc EQ 0.

  CONCATENATE '\bDescription :\b0' <ls_attributes>-descript
  INTO ev_quick_info SEPARATED BY space.

  CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
  INTO ev_quick_info.

*   Select typing like/type/ref to
  CASE <ls_attributes>-typtype.
    WHEN 0.
      lv_typetxt = 'LIKE'.
    WHEN 1.
      lv_typetxt = 'TYPE'.
    WHEN 3.
      lv_typetxt = 'TYPE REF TO'.
    WHEN OTHERS.
      CLEAR lv_decltyp.
  ENDCASE.

  CONCATENATE ev_quick_info '\bType : \b0'
  lv_typetxt <ls_attributes>-type INTO ev_quick_info.

* Append INITIAL value
  IF NOT <ls_attributes>-attvalue IS INITIAL.
    CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
    INTO ev_quick_info.
    CONCATENATE ev_quick_info '\bInitial value : \b0'
    <ls_attributes>-attvalue INTO ev_quick_info.
  ENDIF.

ENDMETHOD.                    "get_attribute_quick_info
METHOD get_bookmarks_as_r3table.
ENDMETHOD.                    "GET_BOOKMARKS_AS_R3TABLE
METHOD get_breakpoints_as_r3table.
ENDMETHOD.                    "GET_BREAKPOINTS_AS_R3TABLE
METHOD get_class_quick_info.
  DATA         : lt_buffer    TYPE TABLE OF seoclasstx,
                   ls_classdef  TYPE seoclassdf,
                   lv_info      TYPE string,
                   lv_date      TYPE char10.
  FIELD-SYMBOLS: <lv_buffer>  LIKE LINE OF lt_buffer.

*   Read author, changer, and time of last change
  SELECT SINGLE * INTO ls_classdef FROM seoclassdf
  WHERE clsname EQ iv_class_name.

*   Prepare string
  IF sy-subrc EQ 0.

*     Prepare data
    IF ls_classdef-changedby IS INITIAL.
      ls_classdef-changedby = ls_classdef-author.
    ENDIF.
    IF ls_classdef-changedon IS INITIAL.
      ls_classdef-changedon = ls_classdef-createdon.
    ENDIF.
    WRITE ls_classdef-changedon DD/MM/YYYY TO lv_date.

* Only for comparing     CLASS cl_abap_char_utilities DEFINITION LOAD.

    CONCATENATE '\bAuthor : \b0' ls_classdef-author
    cl_abap_char_utilities=>newline
    '\bChanged by : \b0' ls_classdef-changedby
    cl_abap_char_utilities=>newline
    '\bLast change on : \b0' lv_date
    INTO lv_info.
  ENDIF.

*   Read list of descriptions for all languages
  SELECT * INTO TABLE lt_buffer FROM seoclasstx
  WHERE clsname EQ iv_class_name.

  get_value_descr langu descript.

ENDMETHOD.                    "get_class_quick_info
METHOD get_data_elem_quick_info.
  DATA         : lt_buffer   TYPE TABLE OF dd04t,
                    ls_dd04l    TYPE dd04l,
                    lv_info     TYPE string,
                    lv_date     TYPE char10.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

  SELECT SINGLE * INTO ls_dd04l FROM dd04l
  WHERE rollname EQ iv_data_elem_name AND as4local EQ 'A'.

*   Prepare string
  WRITE ls_dd04l-as4date DD/MM/YYYY TO lv_date.

* Only for comparing   CLASS cl_abap_char_utilities DEFINITION LOAD.

  CONCATENATE '\bLast changed by : \b0' ls_dd04l-as4user
  cl_abap_char_utilities=>newline
  '\bLast change on : \b0' lv_date
  cl_abap_char_utilities=>newline
  '\bData type : \b0' ls_dd04l-datatype
  ' (' ls_dd04l-leng+4 ',' ls_dd04l-decimals+4 ')'
  INTO lv_info.

*   Read list of descriptions for all languages
  SELECT * INTO TABLE lt_buffer FROM dd04t
  WHERE rollname EQ iv_data_elem_name AND as4local EQ 'A'.

*   Get description by language
  get_value_descr ddlanguage ddtext.

ENDMETHOD.                    "get_data_elem_quick_info
METHOD get_dict_any_type_quick_info.
  CLEAR ev_quick_info.

* Check all possible types if we dont know exactly
  CALL METHOD get_data_elem_quick_info
    EXPORTING
      iv_data_elem_name = iv_dict_any_type
    IMPORTING
      ev_quick_info     = ev_quick_info.

  CHECK ev_quick_info IS INITIAL.

  CALL METHOD get_dict_structure_quick_info
    EXPORTING
      iv_dict_structure = iv_dict_any_type
    IMPORTING
      ev_quick_info     = ev_quick_info.

  CHECK ev_quick_info IS INITIAL.

  CALL METHOD get_table_type_quick_info
    EXPORTING
      iv_table_type = iv_dict_any_type
    IMPORTING
      ev_quick_info = ev_quick_info.

ENDMETHOD.                    "GET_DICT_ANY_TYPE_QUICK_INFO
METHOD get_dict_structure_quick_info.
  DATA         : lt_buffer   TYPE TABLE OF dd04t,
                    ls_dd02l    TYPE dd02l,
                    lv_info     TYPE string,
                    lv_date     TYPE char10.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

  SELECT SINGLE * INTO ls_dd02l FROM dd02l
  WHERE tabname EQ iv_dict_structure AND as4local EQ 'A'.

*   Prepare string
  WRITE ls_dd02l-as4date DD/MM/YYYY TO lv_date.

* Only for comparing   CLASS cl_abap_char_utilities DEFINITION LOAD.

  CONCATENATE '\bLast changed by : \b0' ls_dd02l-as4user
  cl_abap_char_utilities=>newline
  '\bLast change on : \b0' lv_date
  cl_abap_char_utilities=>newline
  '\bTable class : \b0' ls_dd02l-tabclass
  INTO lv_info.

*   Read list of descriptions for all languages
  SELECT * INTO TABLE lt_buffer FROM dd02t
  WHERE tabname EQ iv_dict_structure AND as4local EQ 'A'.

*   Get description by language
  get_value_descr ddlanguage ddtext.

ENDMETHOD.                    "get_dict_structure_quick_info
METHOD get_form_pattern.
  DATA         : lt_source           TYPE report_tbl,
                 o_objecttype        TYPE c,
                 o_objectname        TYPE char255,
                 o_incl              TYPE char40,
                 o_program           LIKE sy-repid.

  FIELD-SYMBOLS: <ls_compo>          LIKE LINE OF gt_compo.

  REFRESH et_pattern.

*   Look for perform
  CALL METHOD update_structure.
  READ TABLE gt_compo WITH KEY type = 'U'
                               name = iv_pattern_key
  ASSIGNING <ls_compo>.

  IF sy-subrc NE 0.
    RAISE not_found.
  ENDIF.

*   Preread report source for scan
  CALL METHOD read_report
    EXPORTING
      iv_report_name = <ls_compo>-incl
    IMPORTING
      et_report      = lt_source.

*   Create perform pattern
  CALL FUNCTION 'RS_SEARCH_FORM'
       EXPORTING
            i_incl        = <ls_compo>-incl
*              i_mainprogram = sel_rahmen
            i_objectname  = <ls_compo>-name
            no_dialog     = gc_true
       IMPORTING
            o_incl        = o_incl
            o_objectname  = o_objectname
            o_objecttype  = o_objecttype
            o_program     = o_program
       TABLES
            i_source      = lt_source
            o_form_tab    = et_pattern.

ENDMETHOD.                    "get_form_pattern
METHOD get_function_pattern.
  DATA : lv_funcname TYPE rs38l_fnam,
            lt_source   TYPE report2_tbl.
*           lt_source   TYPE TABLE OF rssource.

* Clear output
  REFRESH et_pattern.

* Check we have input
  IF iv_pattern_key IS INITIAL OR iv_pattern_key EQ '%'.
    RAISE not_found.
  ENDIF.

* Cast parameter
  MOVE iv_pattern_key TO lv_funcname.

* Get pattern
  CALL FUNCTION 'FUNCTION_STUB_GENERATE'
    EXPORTING
      funcname           = lv_funcname
    TABLES
      SOURCE             = lt_source
    EXCEPTIONS
      function_not_exist = 01.

  IF sy-subrc NE 0.
    RAISE not_found.
  ENDIF.

* Convert to output format
  et_pattern = lt_source.

ENDMETHOD.                    "get_function_pattern
METHOD get_function_quick_info.
  DATA         : lt_buffer  TYPE TABLE OF tftit,
                    lv_info    TYPE string.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

* Only for comparing   CLASS cl_abap_char_utilities DEFINITION LOAD.

*   Read list of descriptions for all languages
  SELECT * INTO TABLE lt_buffer FROM tftit
  WHERE funcname EQ iv_function_name.

*   Get description by language
  get_value_descr spras stext.

ENDMETHOD.                    "get_function_quick_info
METHOD get_message_pattern.
  DATA         : lt_buffer   TYPE TABLE OF t100,
                     lv_mes_num  TYPE char3,
                     ls_source   TYPE string,
                     lv_tmp      TYPE char2,
                     lv_pos      TYPE int4,
                     lv_param    TYPE string.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

  lv_mes_num = iv_pattern_key.

  IF gt_messages IS INITIAL.
    CALL METHOD update_structure.
    CHECK NOT gv_new_rdire-msgid IS INITIAL.
    SELECT * FROM t100 INTO TABLE lt_buffer
    WHERE arbgb EQ gv_new_rdire-msgid AND
          msgnr EQ lv_mes_num.
  ELSE.
    LOOP AT gt_messages ASSIGNING <lv_buffer>
    WHERE msgnr EQ lv_mes_num.
      APPEND <lv_buffer> TO lt_buffer.
    ENDLOOP.
  ENDIF.

  read_by_lang sprsl.

  CONCATENATE 'e' <lv_buffer>-msgnr '('
  <lv_buffer>-arbgb ')' INTO ls_source.
  TRANSLATE ls_source TO LOWER CASE.
  sy-subrc = 0.
  lv_pos   = 1.
  WHILE sy-subrc EQ 0.
    SEARCH <lv_buffer>-text FOR '&' STARTING AT lv_pos.
    CHECK sy-subrc EQ 0.
    lv_pos = lv_pos + sy-fdpos - 1.
    lv_tmp = <lv_buffer>-text+lv_pos.
    lv_pos = lv_pos + 2.
    CONCATENATE lv_param lv_tmp INTO lv_param SEPARATED BY space.
  ENDWHILE.

  IF NOT lv_param IS INITIAL.
    CONCATENATE ls_source 'WITH' lv_param
    INTO ls_source SEPARATED BY space.
  ENDIF.

  CONCATENATE ls_source '. "' <lv_buffer>-text INTO ls_source
  SEPARATED BY space.

  APPEND ls_source TO et_pattern.

ENDMETHOD.                    "get_message_pattern
METHOD get_message_quick_info.

  DATA         : lt_buffer   TYPE TABLE OF t100,
                 lv_mes_num  TYPE char3,
                 lv_info     TYPE string.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

  lv_mes_num = iv_message.

  IF gt_messages IS INITIAL.
    CALL METHOD update_structure.
    CHECK NOT gv_new_rdire-msgid IS INITIAL.
    SELECT * FROM t100 INTO TABLE lt_buffer
    WHERE arbgb EQ gv_new_rdire-msgid AND
          msgnr EQ lv_mes_num.
  ELSE.
    LOOP AT gt_messages ASSIGNING <lv_buffer>
    WHERE msgnr EQ lv_mes_num.
      APPEND <lv_buffer> TO lt_buffer.
    ENDLOOP.
  ENDIF.

  CHECK NOT lt_buffer IS INITIAL.

*   Get description by language
  get_value_descr sprsl text.

ENDMETHOD.                    "get_message_quick_info
METHOD get_method_pattern.
  DATA : ls_mtdkey      TYPE seocpdkey,
             lv_instance    TYPE seoclsname,
             lv_classname   TYPE seoclskey,
             lt_source      TYPE swbse_max_line_tab.
*           lt_source   TYPE TABLE OF rssource.

  FIELD-SYMBOLS: <ls_methods>    LIKE LINE OF gt_methods.

* Clear output
  REFRESH et_pattern.

* Check we have input
  IF iv_pattern_key IS INITIAL OR iv_pattern_key EQ '%'.
    RAISE not_found.
  ENDIF.

* Fill parameter
  IF iv_class_name IS INITIAL.
    READ TABLE gt_methods WITH KEY cmpname = iv_pattern_key
    ASSIGNING <ls_methods>.
    CHECK sy-subrc EQ 0.
    lv_classname = <ls_methods>-clsname.
  ELSE.
    lv_classname = iv_class_name.
  ENDIF.

  ls_mtdkey-clsname = lv_classname.
  ls_mtdkey-cpdname = iv_pattern_key.
  lv_instance       = iv_instance.

* Get pattern
  CALL FUNCTION 'SEOM_CALL_METHOD_PATTERN'
    EXPORTING
      mtdkey        = ls_mtdkey
      instance      = lv_instance
    TABLES
      patternsource = lt_source
    EXCEPTIONS
      OTHERS        = 1.

  IF sy-subrc NE 0.
    RAISE not_found.
  ENDIF.

* Convert to output format
  et_pattern = lt_source.

ENDMETHOD.                    "get_method_pattern
METHOD get_method_quick_info.
  DATA: lv_classname     TYPE seoclskey,
            lt_parameters    TYPE seos_parameters_r,
            lt_exceps        TYPE seos_exceptions_r,
            lt_methods       TYPE seoo_methods_r,
            lv_decltyp       TYPE string,
            lv_typetxt       TYPE string,
            lv_lines         TYPE int4.

  FIELD-SYMBOLS: <ls_parameters> LIKE LINE OF lt_parameters,
                 <ls_methods>    LIKE LINE OF gt_methods,
                 <ls_exceps>     LIKE LINE OF lt_exceps.

  IF iv_class_name IS INITIAL.
    READ TABLE gt_methods WITH KEY cmpname = iv_method_name
    ASSIGNING <ls_methods>.
    CHECK sy-subrc EQ 0.
    lv_classname = <ls_methods>-clsname.
  ELSE.
    lv_classname = iv_class_name.
  ENDIF.

  CALL FUNCTION 'SEO_CLASS_TYPEINFO_GET'
    EXPORTING
      clskey     = lv_classname
    IMPORTING
      methods    = lt_methods
      PARAMETERS = lt_parameters
      exceps     = lt_exceps
    EXCEPTIONS
      OTHERS     = 1.

  IF NOT <ls_methods> IS ASSIGNED.
    READ TABLE lt_methods WITH KEY cmpname = iv_method_name
    ASSIGNING <ls_methods>.
    CHECK sy-subrc EQ 0.
  ENDIF.

  CONCATENATE '\bDescription :\b0' <ls_methods>-descript
  INTO ev_quick_info SEPARATED BY space.

* Only for comparing   CLASS cl_abap_char_utilities DEFINITION LOAD.

  DELETE lt_parameters WHERE cmpname NE iv_method_name.
  DESCRIBE TABLE lt_parameters LINES lv_lines.
  IF NOT lv_lines IS INITIAL.
    IF NOT ev_quick_info IS INITIAL.
      CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
      INTO ev_quick_info.
    ENDIF.
    CONCATENATE ev_quick_info '\bParameters :\b0' INTO ev_quick_info.
    LOOP AT lt_parameters ASSIGNING <ls_parameters>.
      CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
      INTO ev_quick_info.

*       Select type input/output/changing
      CASE <ls_parameters>-pardecltyp.
        WHEN 0.
          lv_decltyp = '>>'.
        WHEN 2.
          lv_decltyp = '<>'.
        WHEN OTHERS.
          lv_decltyp = '<<'.
      ENDCASE.

*       Select typing like/type/ref to
      CASE <ls_parameters>-typtype.
        WHEN 0.
          lv_typetxt = 'LIKE'.
        WHEN 1.
          lv_typetxt = 'TYPE'.
        WHEN 3.
          lv_typetxt = 'TYPE REF TO'.
        WHEN OTHERS.
          CLEAR lv_decltyp.
      ENDCASE.

      CONCATENATE ev_quick_info lv_decltyp <ls_parameters>-sconame
      lv_typetxt <ls_parameters>-type INTO ev_quick_info
      SEPARATED BY space.
    ENDLOOP.
  ENDIF.

  DELETE lt_exceps WHERE cmpname NE iv_method_name.
  DESCRIBE TABLE lt_exceps LINES lv_lines.
  IF NOT lv_lines IS INITIAL.
    IF NOT ev_quick_info IS INITIAL.
      CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
      INTO ev_quick_info.
    ENDIF.
    CONCATENATE ev_quick_info '\bExceptions :\b0'
    INTO ev_quick_info.
    LOOP AT lt_exceps ASSIGNING <ls_exceps>.
      CONCATENATE ev_quick_info cl_abap_char_utilities=>newline
      INTO ev_quick_info.
      CONCATENATE ev_quick_info '  ' <ls_exceps>-sconame
      INTO ev_quick_info SEPARATED BY space.
    ENDLOOP.
  ENDIF.

ENDMETHOD.                    "get_method_quick_info
METHOD get_protected_lines_as_r3table.
ENDMETHOD.                    "GET_PROTECTED_LINES_AS_R3TABLE
METHOD get_report.
  DATA         : ls_sources    LIKE LINE OF gt_sources,
                     lv_version    LIKE gv_version.

  FIELD-SYMBOLS: <ls_sources>  LIKE LINE OF gt_sources,
                 <ls_report>   LIKE LINE OF et_report.

  REFRESH et_report.

  CALL METHOD get_property
    EXPORTING
      property          = 'Version'
      queue_only        = space
    IMPORTING
      value             = lv_version
    EXCEPTIONS
      cntl_system_error = 1
      cntl_error        = 2
      OTHERS            = 3.

*  CALL METHOD call_method
*    EXPORTING
*      method = 'GetVersion'
*    IMPORTING
*      RESULT = lv_version
*    EXCEPTIONS
*      OTHERS = 1.

  CALL METHOD cl_gui_cfw=>flush
    EXCEPTIONS
      OTHERS = 1.

* If text was not modified - read buffer
  IF lv_version <= gv_version.
*   Check buffer
    READ TABLE gt_sources WITH KEY include = gv_report_name
    TRANSPORTING NO FIELDS.
    IF sy-subrc EQ 0.
      IF et_report IS REQUESTED.
*     Take entries from the buffer
        LOOP AT gt_sources ASSIGNING <ls_sources> FROM sy-tabix.
          IF <ls_sources>-include NE gv_report_name.
            EXIT.
          ENDIF.
          APPEND <ls_sources>-line TO et_report.
        ENDLOOP.
      ENDIF.
      EXIT.
    ENDIF.
  ENDIF.

* Save version
  gv_version       = lv_version.
  gv_struct_update = gc_true.

* If text was modified or not in buffer get it from the frontend
  CALL METHOD get_text_as_r3table
    IMPORTING
      table = et_report.

  CALL METHOD cl_gui_cfw=>flush
    EXCEPTIONS
      OTHERS = 1.

*   Delete all entries from buffer
  READ TABLE gt_sources WITH KEY include = gv_report_name
  TRANSPORTING NO FIELDS.
  IF sy-subrc EQ 0.
*     Check source buffer table
    LOOP AT gt_sources ASSIGNING <ls_sources> FROM sy-tabix.
      IF <ls_sources>-include NE gv_report_name.
        EXIT.
      ENDIF.
      DELETE gt_sources.
    ENDLOOP.
  ENDIF.

*   Add updated source
  ls_sources-include = gv_report_name.
  LOOP AT et_report ASSIGNING <ls_report>.
    ls_sources-line = <ls_report>.
    APPEND ls_sources TO gt_sources.
  ENDLOOP.

ENDMETHOD.                    "GET_REPORT
METHOD get_selected_text_as_r3table.
ENDMETHOD.                    "GET_SELECTED_TEXT_AS_R3TABLE
METHOD get_struct_comp_quick_info.
  DATA         : lv_string      TYPE string.
  FIELD-SYMBOLS: <ls_component> LIKE LINE OF gt_nametab.

  lv_string = iv_str_comp_name.

  TRANSLATE lv_string TO UPPER CASE.

  READ TABLE gt_nametab WITH KEY fieldname = lv_string
  ASSIGNING <ls_component>.

  CHECK sy-subrc EQ 0.

  MOVE <ls_component>-rollname TO lv_string.

  CALL METHOD get_data_elem_quick_info
    EXPORTING
      iv_data_elem_name = lv_string
    IMPORTING
      ev_quick_info     = ev_quick_info.

ENDMETHOD.                    "get_struct_comp_quick_info
METHOD get_table_type_quick_info.
  DATA         : lt_buffer   TYPE TABLE OF dd04t,
                     ls_dd40l    TYPE dd40l,
                     lv_info     TYPE string,
                     lv_date     TYPE char10.
  FIELD-SYMBOLS: <lv_buffer> LIKE LINE OF lt_buffer.

  SELECT SINGLE * INTO ls_dd40l FROM dd40l
  WHERE typename EQ iv_table_type AND as4local EQ 'A'.

  IF sy-subrc NE 0.
    RAISE not_found.
  ENDIF.

  ev_row_type = ls_dd40l-rowtype.

  CHECK ev_quick_info IS REQUESTED.

*   Prepare string
  WRITE ls_dd40l-as4date DD/MM/YYYY TO lv_date.

* Only for comparing   CLASS cl_abap_char_utilities DEFINITION LOAD.

  CONCATENATE '\bLast changed by : \b0' ls_dd40l-as4user
  cl_abap_char_utilities=>newline
  '\bLast change on : \b0' lv_date
  cl_abap_char_utilities=>newline
  '\bRow type : \b0' ls_dd40l-rowtype
  cl_abap_char_utilities=>newline
  '\bData type : \b0' ls_dd40l-datatype
  ' (' ls_dd40l-leng+4 ',' ls_dd40l-decimals+4 ')'
  INTO lv_info.

*   Read list of descriptions for all languages
  SELECT * INTO TABLE lt_buffer FROM dd40t
  WHERE typename EQ iv_table_type AND as4local EQ 'A'.

*   Get description by language
  get_value_descr ddlanguage ddtext.

ENDMETHOD.                    "get_table_type_quick_info
METHOD get_text_as_r3table.
  TYPES: src_line_type(120) TYPE x.
  TYPES src_type TYPE STANDARD TABLE OF src_line_type.
  DATA: "source_string type string,
        source_table TYPE src_type,
        wa_src1 TYPE src_line_type,
        wa_src TYPE string,
        m_size TYPE i.
  CALL METHOD call_method
    EXPORTING
      method  = 'SaveSelectedTextToDP'
      p_count = 1
      p1      = m_dp_handle.

* get table/stream from frontend
  CALL FUNCTION 'DP_GET_STREAM'
    EXPORTING
      h_dp                   = m_dp_handle
*      ACCEPTTYPE             = MIMETYPE
*      ACCEPTSUBTYPE          = MIMESUBTYPE
    IMPORTING
       size                   = m_size
*      TYPE                   = MIMETYPE
*      SUBTYPE                = MIMESUBTYPE
    TABLES
      data                   = source_table
    EXCEPTIONS
      dp_error_get_data      = 1
      dp_error_invalid_param = 2
      dp_error_no_data       = 3
      dp_error_general       = 4
      OTHERS                 = 5.
  IF sy-subrc <> 0.
    RAISE error_dp.
  ENDIF.

  DATA: encoding                    TYPE abap_encod.
  encoding = 'utf-16le'.
  DATA: codepage            TYPE cpcodepage.

  CALL FUNCTION 'SCP_CODEPAGE_BY_EXTERNAL_NAME'
    EXPORTING
      external_name = encoding
    IMPORTING
      sap_codepage  = codepage
    EXCEPTIONS
      not_found     = 1
      OTHERS        = 2.

  encoding = codepage.
  CALL FUNCTION 'SCMS_BINARY_TO_FTEXT'
    EXPORTING
      input_length          = m_size
*   FIRST_LINE            = 0
*   LAST_LINE             = 0
*   APPEND_TO_TABLE       = ' '
*   MIMETYPE              = ' '
* IMPORTING
*   OUTPUT_LENGTH         = OUTPUT_LENGTH
    TABLES
      binary_tab            = source_table
      ftext_tab             = table
* EXCEPTIONS
*   FAILED                = 1
*   OTHERS                = 2
           .
  IF sy-subrc <> 0.
* MESSAGE ID SY-MSGID TYPE SY-MSGTY NUMBER SY-MSGNO
*         WITH SY-MSGV1 SY-MSGV2 SY-MSGV3 SY-MSGV4.
  ENDIF.

ENDMETHOD.                    "GET_TEXT_AS_R3TABLE
METHOD get_text_element_pattern.
  DATA         : lv_elem_num  TYPE char3,
                     ls_source    TYPE string.
  FIELD-SYMBOLS: <ls_buffer>  LIKE LINE OF gt_textpool.

  IF gt_textpool IS INITIAL.
    CALL METHOD prepare_text_element_list
      EXPORTING
        iv_pattern = space.
  ENDIF.

  lv_elem_num = iv_pattern_key.

  READ TABLE gt_textpool WITH KEY key = lv_elem_num
  ASSIGNING <ls_buffer>.
  CHECK sy-subrc EQ 0.

  ls_source = <ls_buffer>-key.

  APPEND ls_source TO et_pattern.

ENDMETHOD.                    "get_text_element_pattern
METHOD get_text_element_quick_info.
  DATA         : lv_elem_num  TYPE char3,
                     lv_length    TYPE numc3.
  FIELD-SYMBOLS: <ls_buffer>  LIKE LINE OF gt_textpool.

  IF gt_textpool IS INITIAL.
    CALL METHOD prepare_text_element_list
      EXPORTING
        iv_pattern = space.
  ENDIF.

  lv_elem_num = iv_text_elem.

  READ TABLE gt_textpool WITH KEY key = lv_elem_num
  ASSIGNING <ls_buffer>.
  CHECK sy-subrc EQ 0.

  WRITE <ls_buffer>-length TO lv_length.

  CONCATENATE '\bKey: \b0' <ls_buffer>-key
  cl_abap_char_utilities=>newline
  '\bText: \b0' <ls_buffer>-entry
  cl_abap_char_utilities=>newline
  '\bLength: \b0' lv_length INTO ev_quick_info.


ENDMETHOD.                    "get_text_element_quick_info
METHOD get_type.
  DATA : lv_definition     LIKE iv_definition,
            lv_type_name      TYPE string,
            lt_words          TYPE words_tbl,
            lv_check_again    TYPE boolean,
            lv_row_str        TYPE boolean,
            ls_pos            TYPE point,
            lv_type           TYPE int4,
            lv_tabix          TYPE int4.

  FIELD-SYMBOLS : <ls_word>  LIKE LINE OF lt_words.

  CHECK NOT iv_definition IS INITIAL.
  lv_definition = iv_definition.
  lv_row_str    = iv_row_str.

  TRANSLATE lv_definition TO UPPER CASE.
  SPLIT lv_definition AT space INTO TABLE lt_words.

*     Organize table with words
  LOOP AT lt_words ASSIGNING <ls_word>.
    CONDENSE <ls_word> NO-GAPS.
    CHECK <ls_word> IS INITIAL    OR
          <ls_word> EQ 'OF'       OR
          <ls_word> EQ 'STANDARD' OR
          <ls_word> EQ 'INDEXED'  OR
          <ls_word> EQ 'SORTED'   OR
          <ls_word> EQ 'HASHED'.
    DELETE lt_words.
  ENDLOOP.

  READ TABLE lt_words WITH KEY table_line = 'TO'
  TRANSPORTING NO FIELDS.
  IF sy-subrc NE 0.
    READ TABLE lt_words WITH KEY table_line = 'TYPE'
    TRANSPORTING NO FIELDS.
    IF sy-subrc NE 0.
      READ TABLE lt_words WITH KEY table_line = 'LIKE'
      TRANSPORTING NO FIELDS.
      CHECK sy-subrc EQ 0.
      lv_check_again = gc_true.
    ENDIF.
  ENDIF.

  lv_tabix = sy-tabix + 1.
  READ TABLE lt_words INDEX 1 INTO ev_comp_name.
  READ TABLE lt_words INDEX lv_tabix INTO ev_type_name.
*   Read table line structure
  IF lv_row_str EQ gc_true.
    IF ev_type_name EQ 'TABLE'.
      lv_tabix = lv_tabix + 1.
      READ TABLE lt_words INDEX lv_tabix INTO ev_type_name.
*   Check that we found correct value
      CALL METHOD is_dictionary_type
        EXPORTING
          iv_dict_any_type = ev_type_name
        IMPORTING
          ev_type          = lv_type.
*   If we have local type - check again
      IF lv_type EQ mc_wt_all.
        lv_check_again = gc_true.
      ENDIF.
    ELSE.
      CALL METHOD get_table_type_quick_info
        EXPORTING
          iv_table_type = ev_type_name
        IMPORTING
          ev_row_type   = ev_type_name
        EXCEPTIONS
          OTHERS        = 1.
      IF sy-subrc NE 0.
        lv_check_again = gc_true.
      ENDIF.
    ENDIF.
  ENDIF.

*   If we have declaration with LIKE we need to search for type further
  CHECK lv_check_again EQ gc_true.

*   Check if we have line structure
  IF ev_type_name EQ 'LINE'.
    lv_tabix = lv_tabix + 1.
    READ TABLE lt_words INDEX lv_tabix INTO ev_type_name.
    CHECK sy-subrc EQ 0.
    lv_row_str = gc_true.
  ENDIF.

  SEARCH iv_line FOR ev_type_name.
  ls_pos-xpos = sy-fdpos.
  ls_pos-ypos = is_def_pos-ypos.
  CALL METHOD get_type_by_object
    EXPORTING
      iv_pos       = ls_pos
      iv_rep_name  = iv_rep_name
      iv_row_str   = lv_row_str
    IMPORTING
      ev_type_name = ev_type_name
    EXCEPTIONS
      OTHERS       = 1.

ENDMETHOD.                    "get_type
METHOD get_type_by_object.
  DATA: lt_report         TYPE report_tbl,
            lv_rep_name       LIKE sy-repid,
            lv_row            LIKE sy-index,
            lv_col            LIKE sy-index,
            lv_incl           TYPE trdir-name,
            lv_program        LIKE sy-repid,
            lv_event          TYPE char64,
            lv_eventtype      TYPE c,
            lv_class          TYPE char64,
            lv_classtype      TYPE c,
            lv_local          TYPE boolean,
            lv_objectname     TYPE char64,
            lv_objecttype     TYPE char2,
            lv_operation      TYPE char10,
            lv_comments       TYPE string,
            lv_instance_def   TYPE string,
            lv_line           TYPE string,
            ls_pos            TYPE point.

  FIELD-SYMBOLS : <ls_compo> LIKE LINE OF gt_compo.

*   Load report
  IF iv_rep_name IS INITIAL.
    lv_rep_name = gv_report_name.
    CALL METHOD get_report
      IMPORTING
        et_report = lt_report.
  ELSE.
    lv_rep_name = iv_rep_name.
    CALL METHOD read_report
      EXPORTING
        iv_report_name = lv_rep_name
      IMPORTING
        et_report      = lt_report.
  ENDIF.

*   Check local variables
  CALL FUNCTION 'RS_NAVIGATION_PREPARE'
    EXPORTING
      i_col         = iv_pos-xpos
      i_row         = iv_pos-ypos
      i_editor      = 'EDTR'
      i_incl        = lv_rep_name
      i_operation   = 'DEFINITION'
      i_mainprogram = gv_main_prog
      no_dialog     = gc_true
    IMPORTING
      o_col         = lv_col
      o_row         = lv_row
      o_event       = lv_event
      o_eventtype   = lv_eventtype
      o_class       = lv_class
      o_classtype   = lv_classtype
      o_incl        = lv_incl
      o_local       = lv_local
      o_objectname  = lv_objectname
      o_objecttype  = lv_objecttype
      o_operation   = lv_operation
      o_program     = lv_program
    TABLES
      i_source      = lt_report.

  TRANSLATE lv_class TO UPPER CASE.
  TRANSLATE lv_objectname TO UPPER CASE.
  TRANSLATE lv_event TO UPPER CASE.

*   If variable is not local, check global
  IF lv_local EQ gc_false.

*   Update structure
    CALL METHOD update_structure.

*   take only parent object
    SEARCH lv_objectname FOR '-'.
    IF sy-subrc EQ 0.
      lv_objectname = lv_objectname(sy-fdpos).
    ENDIF.

    READ TABLE gt_compo WITH KEY name = lv_objectname
    ASSIGNING <ls_compo>.
    IF sy-subrc EQ 0.
      IF <ls_compo>-incl NE lv_rep_name.
*        Load report
        lv_rep_name = <ls_compo>-incl.
        CALL METHOD read_report
          EXPORTING
            iv_report_name = lv_rep_name
          IMPORTING
            et_report      = lt_report.
      ENDIF.

      IF lv_objecttype = 'Y'.
        CALL FUNCTION 'RS_TYPE_POSITION'
          EXPORTING
            object_name = lv_objectname
            object_type = lv_objecttype
            typgr_incl  = lv_rep_name
          IMPORTING
            col         = lv_col
            row         = lv_row
            include     = lv_rep_name
          TABLES
            SOURCE      = lt_report
          EXCEPTIONS
            OTHERS      = 1.
      ELSEIF lv_objecttype = 'D'.
        CALL FUNCTION 'RS_OBJECT_POSITION'
          EXPORTING
            object_name = lv_objectname
            object_type = lv_objecttype
          IMPORTING
            col         = lv_col
            row         = lv_row
          TABLES
            SOURCE      = lt_report
          EXCEPTIONS
            OTHERS      = 1.
      ENDIF.
    ENDIF.
  ENDIF.

  IF lv_rep_name NE lv_incl AND NOT lv_incl IS INITIAL.
*     Load report
    lv_rep_name = lv_incl.
    CALL METHOD read_report
      EXPORTING
        iv_report_name = lv_rep_name
      IMPORTING
        et_report      = lt_report.
  ENDIF.

  IF NOT lv_row IS INITIAL OR
     NOT lv_col IS INITIAL.

    READ TABLE lt_report INDEX lv_row INTO lv_line.
    lv_instance_def = lv_line.
    SHIFT lv_instance_def BY lv_col PLACES.

* Replace not translated characters
    replace_all_occurrences cl_abap_char_utilities=>horizontal_tab
    '.' lv_instance_def.

* Get comments
    SEARCH lv_instance_def FOR '"'.
    IF sy-subrc EQ 0.
      lv_comments = lv_instance_def+sy-fdpos.
      CONDENSE lv_comments.
      CONCATENATE '\b' lv_comments INTO lv_comments.
      lv_instance_def = lv_instance_def(sy-fdpos).
    ENDIF.
    CONDENSE lv_instance_def.
    TRANSLATE lv_instance_def USING '. , '.

    CONCATENATE lv_instance_def lv_comments INTO ev_instance_def
    SEPARATED BY space.

  ENDIF.

  ev_object_name = lv_objectname.
  ev_parent      = lv_class.

* Adopt types
  CALL METHOD convert_types
    EXPORTING
      iv_ext_type = lv_objecttype
    IMPORTING
      ev_int_type = ev_type_id.

* Extract type of object from definition
  IF  ev_type_name    IS REQUESTED.
    ls_pos-xpos = lv_col.
    ls_pos-ypos = lv_row.
    CALL METHOD get_type
      EXPORTING
        iv_rep_name   = lv_rep_name
        iv_line       = lv_line
        iv_definition = lv_instance_def
        iv_row_str    = iv_row_str
        is_def_pos    = ls_pos
      IMPORTING
        ev_type_name  = ev_type_name
        ev_comp_name  = ev_object_name
      EXCEPTIONS
        OTHERS        = 1.
  ENDIF.

ENDMETHOD.                    "get_type_by_object
METHOD is_dictionary_type.
  DATA : lv_temp   TYPE c.

  CHECK NOT iv_dict_any_type IS INITIAL.

*   Check table types
  ev_type = mc_wt_dict_table_type.
  SELECT SINGLE typename INTO lv_temp FROM dd40l
  WHERE typename EQ iv_dict_any_type AND as4local EQ 'A'.

*   Check structures
  CHECK sy-subrc NE 0.
  ev_type = mc_wt_dict_structure.
  SELECT SINGLE tabname INTO lv_temp FROM dd02l
  WHERE tabname EQ iv_dict_any_type AND as4local EQ 'A'.

*   Check data elements
  CHECK sy-subrc NE 0.
  ev_type = mc_wt_dict_data_elem.
  SELECT SINGLE rollname INTO lv_temp FROM dd04l
  WHERE rollname EQ iv_dict_any_type AND as4local EQ 'A'.

  CHECK sy-subrc NE 0.
  ev_type = mc_wt_all.

ENDMETHOD.                    "is_dictionary_type
* Only for comparing METHOD load.
*@78\QImporting@	REPORT_NAME	TYPE SYREPID	ABAP Program: Current Main Program

  DATA: lt_report     TYPE report_tbl,
           lt_progdir    LIKE gt_progdir,
           lt_mainprog   TYPE TABLE OF sy-repid,
           ls_sources    LIKE LINE OF gt_sources.

  FIELD-SYMBOLS: <ls_report>  LIKE LINE OF lt_report.

  CHECK NOT report_name IS INITIAL.

* Check existense and attributes
  CALL FUNCTION 'RPY_EXISTENCE_CHECK_PROG'
    EXPORTING
      name        = report_name
    TABLES
      progdir_tab = lt_progdir
    EXCEPTIONS
      not_exist   = 1
      OTHERS      = 2.

  CHECK sy-subrc EQ 0.

  gt_progdir = lt_progdir.
  gv_report_name = report_name.

* Refresh buffers
  CALL METHOD refresh_buffers.

* Get main program
  CALL FUNCTION 'RS_GET_MAINPROGRAMS'
    EXPORTING
      name            = gv_report_name
      dialog_required = gc_true
    TABLES
      mainprograms    = lt_mainprog
    EXCEPTIONS
      OTHERS          = 1.

  IF sy-subrc EQ 0.
    READ TABLE lt_mainprog INDEX 1 INTO gv_main_prog.
  ENDIF.

*   Load report
  CALL METHOD read_report
    EXPORTING
      iv_report_name = gv_report_name
    IMPORTING
      et_report      = lt_report.

**   Delete previous contents and variables
*  CALL METHOD call_method
*    EXPORTING
*      method = 'DeleteContents'
*    EXCEPTIONS
*      OTHERS = 1.

*  send table to control
  CALL METHOD set_text_as_r3table
    EXPORTING
      table = lt_report.

  CALL METHOD call_method
    EXPORTING
      method  = 'LoadDocFromDP'
      p1      = report_name
      p2      = m_dp_handle
      p_count = 2
    EXCEPTIONS
      OTHERS  = 1.

ENDMETHOD.                    "LOAD
METHOD on_command_execute.
  DATA: dummy TYPE i.
  CALL METHOD call_method
    EXPORTING
      method     = 'OnCommandExecute'
      p1         = i_command
      p_count    = 1
      queue_only = ''
    IMPORTING
      RESULT     = dummy
    EXCEPTIONS
      OTHERS     = 1.
  cl_gui_cfw=>flush( ).
ENDMETHOD.                    "ON_COMMAND_EXECUTE
METHOD on_completion.
  DATA: lv_data_type           TYPE int4,
        lv_pattern             TYPE string,
        lv_parent              TYPE string,
        lv_def_start           TYPE i,
        lv_usesimpleautocompl  TYPE i,
        lv_useinternaldict     TYPE i,
        lt_list                TYPE comp_dict_tbl,
        lv_length              TYPE i,
        lv_pos                 TYPE point.

* Store call point
  gs_end      = iv_pos.

* First analyze provide context string
  CALL METHOD analyze_context
    EXPORTING
      iv_context_string = iv_context_string
      iv_pos            = iv_pos-xpos
    IMPORTING
      ev_data_type      = lv_data_type
      ev_def_start      = lv_def_start
      ev_parent         = lv_parent
      ev_pattern        = lv_pattern.

* Store start of definition
  gs_start-xpos = lv_def_start.
  gs_start-ypos = iv_pos-ypos.

* Then fill autocompletion list with needed data by data_type
* First check dictionary
  CASE lv_data_type.

    WHEN mc_wt_function.
      CALL METHOD prepare_function_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_transaction.
      CALL METHOD prepare_transaction_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_screen.
      CALL METHOD prepare_dynpro_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_object.
      CALL METHOD prepare_dict_class_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_type_pool.
      CALL METHOD prepare_type_pool_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_message.
      CALL METHOD prepare_message_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_text_element.
      CALL METHOD prepare_text_element_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_table.
      CALL METHOD prepare_dict_structure_list
        EXPORTING
          iv_data_type = mc_wt_table
          iv_pattern   = lv_pattern
        CHANGING
          ct_list      = lt_list.

    WHEN mc_wt_domain_values.
      CALL METHOD prepare_domain_values_list
        EXPORTING
          iv_parent  = lv_parent
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_type.
      CALL METHOD prepare_dict_structure_list
        EXPORTING
          iv_data_type = mc_wt_dict_structure
          iv_pattern   = lv_pattern
        CHANGING
          ct_list      = lt_list.

      CALL METHOD prepare_dict_data_elem_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

      CALL METHOD prepare_dict_table_type_list
        EXPORTING
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list.

    WHEN mc_wt_method_class    OR
         mc_wt_method_instance.
      CALL METHOD prepare_class_methods_list
        EXPORTING
          iv_data_type = lv_data_type
          iv_parent    = lv_parent
          iv_pattern   = lv_pattern
        CHANGING
          ct_list      = lt_list
        EXCEPTIONS
          OTHERS       = 1.

      IF sy-subrc NE 0.
        SEARCH iv_context_string FOR lv_parent.
        IF sy-subrc EQ 0.
          lv_pos-ypos = iv_pos-ypos + 1.
          lv_pos-xpos = sy-fdpos.
          CALL METHOD get_type_by_object
            EXPORTING
              iv_pos         = lv_pos
            IMPORTING
              ev_object_name = gv_parent
              ev_type_name   = lv_parent.

          CALL METHOD prepare_class_methods_list
            EXPORTING
              iv_data_type = lv_data_type
              iv_parent    = lv_parent
              iv_pattern   = lv_pattern
            CHANGING
              ct_list      = lt_list
            EXCEPTIONS
              OTHERS       = 1.
        ENDIF.
      ENDIF.

    WHEN mc_wt_attrib_class OR
         mc_wt_attrib_instance.
      CALL METHOD prepare_class_attributes_list
        EXPORTING
          iv_data_type = lv_data_type
          iv_parent    = lv_parent
          iv_pattern   = lv_pattern
        CHANGING
          ct_list      = lt_list
        EXCEPTIONS
          OTHERS       = 1.

      IF sy-subrc NE 0.
        SEARCH iv_context_string FOR lv_parent.
        IF sy-subrc EQ 0.
          lv_pos-ypos = iv_pos-ypos + 1.
          lv_pos-xpos = sy-fdpos.
          CALL METHOD get_type_by_object
            EXPORTING
              iv_pos         = lv_pos
            IMPORTING
              ev_object_name = gv_parent
              ev_type_name   = lv_parent.

          CALL METHOD prepare_class_attributes_list
            EXPORTING
              iv_data_type = lv_data_type
              iv_parent    = lv_parent
              iv_pattern   = lv_pattern
            CHANGING
              ct_list      = lt_list
            EXCEPTIONS
              OTHERS       = 1.
        ENDIF.
      ENDIF.

    WHEN mc_wt_structure_field.

      CALL METHOD prepare_struct_component_list
        EXPORTING
          iv_parent  = lv_parent
          iv_pattern = lv_pattern
        CHANGING
          ct_list    = lt_list
        EXCEPTIONS
          OTHERS     = 1.

      IF sy-subrc NE 0.
        SEARCH iv_context_string FOR lv_parent.
        IF sy-subrc EQ 0.
          lv_pos-ypos = iv_pos-ypos + 1.
          lv_pos-xpos = sy-fdpos.
          CALL METHOD get_type_by_object
            EXPORTING
              iv_pos         = lv_pos
            IMPORTING
              ev_object_name = gv_parent
              ev_type_name   = lv_parent
            EXCEPTIONS
              OTHERS         = 1.

          CALL METHOD prepare_struct_component_list
            EXPORTING
              iv_parent  = lv_parent
              iv_pattern = lv_pattern
            CHANGING
              ct_list    = lt_list
            EXCEPTIONS
              OTHERS     = 1.
        ENDIF.
      ENDIF.

    WHEN OTHERS.
  ENDCASE.

*   Add program global variables
  CALL METHOD prepare_program_index_list
    EXPORTING
      iv_data_type = lv_data_type
      iv_pattern   = lv_pattern
    CHANGING
      ct_list      = lt_list.

* If we have selection with a mask, clear mask on editor
* to not have it closed
  lv_length = STRLEN( lv_pattern ) - 1.
  SEARCH lv_pattern FOR '%' ENDING AT lv_length.
  IF sy-subrc EQ 0.
    lv_pos-xpos = iv_pos-xpos - lv_length + sy-fdpos.
    lv_pos-ypos = iv_pos-ypos.
    CALL METHOD delete_text
      EXPORTING
        is_start = lv_pos
        is_end   = iv_pos.
  ENDIF.

* For cases when we looked for concrete data type disable
* controls dictionaries
  IF lv_data_type NE mc_wt_variable AND
     lv_data_type NE mc_wt_all.

**--> Save current settings
*    CALL METHOD get_property
*      EXPORTING
*        property = 'bUseInternalDict'
*      IMPORTING
*        value    = lv_useinternaldict.
*
*    CALL METHOD get_property
*      EXPORTING
*        property = 'bUseSimpleAutoCompl'
*      IMPORTING
*        value    = lv_usesimpleautocompl.
*
**-->Transport values from the FrontEnd
*    CALL METHOD cl_gui_cfw=>flush.
*
**--> Disable dictionaries
*    CALL METHOD set_property
*      EXPORTING
*        property = 'bUseInternalDict'
*        value    = cfalse.
*
*    CALL METHOD set_property
*      EXPORTING
*        property = 'bUseSimpleAutoCompl'
*        value    = cfalse.

  ENDIF.

* Provide dictionary
*  set_table_property 'ExtDictAsR3Table' lt_list.

  IF lv_data_type NE mc_wt_variable AND
     lv_data_type NE mc_wt_all.

* Set settings for dictionary back
    CALL METHOD set_property
      EXPORTING
        property = 'bUseInternalDict'
        value    = lv_useinternaldict.

    CALL METHOD set_property
      EXPORTING
        property = 'bUseSimpleAutoCompl'
        value    = lv_usesimpleautocompl.
  ENDIF.

ENDMETHOD.                    "on_complition
METHOD on_help.
  DATA : lv_word TYPE tdanweisng.

  lv_word = iv_current_word.

  CALL FUNCTION 'EDITOR_ABAP_DOCU'
    EXPORTING
      word = lv_word.
ENDMETHOD.                    "on_help
METHOD on_insert_pattern.
  DATA : lv_pattern_key        TYPE string,
             lt_pattern            TYPE TABLE OF char255,
             lv_block_sel          TYPE int4,
             lv_indent             TYPE string,
             lv_format_after_paste TYPE i,
             lv_lines              TYPE i,
             ls_buffer             LIKE LINE OF lt_pattern.

  FIELD-SYMBOLS : <ls_pattern> LIKE LINE OF lt_pattern.

* check handle
  IF h_control IS INITIAL.
    RAISE error.
  ENDIF.

  lv_pattern_key = iv_pattern_key.
  TRANSLATE lv_pattern_key TO UPPER CASE.

  CASE iv_data_type.
    WHEN mc_wt_function.
* Provide function pattern
      CALL METHOD get_function_pattern
        EXPORTING
          iv_pattern_key = lv_pattern_key
        IMPORTING
          et_pattern     = lt_pattern.

    WHEN mc_wt_form.
      CALL METHOD get_form_pattern
        EXPORTING
          iv_pattern_key = lv_pattern_key
        IMPORTING
          et_pattern     = lt_pattern.

    WHEN mc_wt_method_class OR
         mc_wt_method_instance.
      CALL METHOD get_method_pattern
        EXPORTING
          iv_instance    = gv_parent
          iv_class_name  = space
          iv_pattern_key = lv_pattern_key
        IMPORTING
          et_pattern     = lt_pattern.

    WHEN mc_wt_message.
      CALL METHOD get_message_pattern
        EXPORTING
          iv_pattern_key = lv_pattern_key
        IMPORTING
          et_pattern     = lt_pattern.

    WHEN mc_wt_text_element.
      CALL METHOD get_text_element_pattern
        EXPORTING
          iv_pattern_key = lv_pattern_key
        IMPORTING
          et_pattern     = lt_pattern.

    WHEN OTHERS.
      ls_buffer = lv_pattern_key.
      TRANSLATE ls_buffer TO LOWER CASE.
      APPEND ls_buffer TO lt_pattern.
  ENDCASE.

  CHECK NOT lt_pattern IS INITIAL.

  lv_lines = LINES( lt_pattern ).

*  IF lv_lines EQ 1.
*    CALL METHOD get_property
*      EXPORTING
*        property = 'bFormatAfterPaste'
*      IMPORTING
*        value    = lv_format_after_paste.
*
**-->Transport values from the FrontEnd
*    CALL METHOD cl_gui_cfw=>flush.
*
*    CALL METHOD set_property
*      EXPORTING
*        property = 'bFormatAfterPaste'
*        value    = cfalse.
*  ENDIF.

*   Set selection
  CALL METHOD call_method
    EXPORTING
      method  = 'SetSelectionPosInLine'
      p1      = gs_start-ypos
      p2      = gs_start-xpos
*      p3      = iv_pos-ypos
*      p4      = iv_pos-xpos
      p_count = 2
    EXCEPTIONS
      OTHERS  = 1.

*   Paste pattern with new selected text
  CALL METHOD set_selected_text_as_r3table
    EXPORTING
      table = lt_pattern.

* load data from dataprovider object
  CALL METHOD call_method
    EXPORTING
      method  = 'LoadSelectedTextFromDP'
      p_count = 1
      p1      = m_dp_handle.

*  IF lv_lines EQ 1.
*    CALL METHOD set_property
*      EXPORTING
*        property = 'bFormatAfterPaste'
*        value    = lv_format_after_paste.
*  ENDIF.

  IF sy-subrc <> 0.
    RAISE error.
  ENDIF.

ENDMETHOD.                    "ON_INSERT_PATTERN
METHOD on_navigate.

ENDMETHOD.                    "ON_NAVIGATE
METHOD on_quick_info.
  DATA : lv_context_string  TYPE string,
           lv_data_type       LIKE iv_data_type,
           lv_string          TYPE string,
           lv_parent          TYPE string,
           lv_pos             TYPE point.

  DATA: l_pos LIKE iv_pos.
  l_pos = iv_pos.
  l_pos-ypos = l_pos-ypos - 1.
  IF l_pos-ypos < 1.
    l_pos-ypos = 1.
  ENDIF.

* check handle
  IF h_control IS INITIAL.
    RAISE error.
  ENDIF.

  lv_context_string = iv_context_string.
  TRANSLATE lv_context_string TO UPPER CASE.

  lv_data_type = iv_data_type.

  IF lv_data_type IS INITIAL.
    CALL METHOD get_type_by_object
      EXPORTING
        iv_pos          = l_pos
      IMPORTING
        ev_type_id      = lv_data_type
        ev_object_name  = lv_context_string
        ev_instance_def = lv_string
        ev_parent       = lv_parent.
  ENDIF.

  CASE lv_data_type.
    WHEN mc_wt_function.
      CALL METHOD get_function_quick_info
        EXPORTING
          iv_function_name = lv_context_string
        IMPORTING
          ev_quick_info    = lv_string.
    WHEN mc_wt_object.
      CALL METHOD get_class_quick_info
        EXPORTING
          iv_class_name = lv_context_string
        IMPORTING
          ev_quick_info = lv_string.
    WHEN mc_wt_dict_data_elem.
      CALL METHOD get_data_elem_quick_info
        EXPORTING
          iv_data_elem_name = lv_context_string
        IMPORTING
          ev_quick_info     = lv_string.
    WHEN mc_wt_dict_structure.
      CALL METHOD get_dict_structure_quick_info
        EXPORTING
          iv_dict_structure = lv_context_string
        IMPORTING
          ev_quick_info     = lv_string.
    WHEN mc_wt_dict_table_type.
      CALL METHOD get_table_type_quick_info
        EXPORTING
          iv_table_type = lv_context_string
        IMPORTING
          ev_quick_info = lv_string.
    WHEN mc_wt_dict_any_type.
      CALL METHOD get_dict_any_type_quick_info
        EXPORTING
          iv_dict_any_type = lv_context_string
        IMPORTING
          ev_quick_info    = lv_string.
    WHEN mc_wt_method_all      OR
         mc_wt_method_class    OR
         mc_wt_method_instance.
      CALL METHOD get_method_quick_info
        EXPORTING
          iv_class_name  = lv_parent
          iv_method_name = lv_context_string
        IMPORTING
          ev_quick_info  = lv_string.
    WHEN mc_wt_attribute_all OR
         mc_wt_attrib_class  OR
         mc_wt_attrib_instance.
      CALL METHOD get_attribute_quick_info
        EXPORTING
          iv_class_name  = lv_parent
          iv_attrib_name = lv_context_string
        IMPORTING
          ev_quick_info  = lv_string.
    WHEN mc_wt_structure_field.
      CALL METHOD get_struct_comp_quick_info
        EXPORTING
          iv_str_comp_name = lv_context_string
        IMPORTING
          ev_quick_info    = lv_string.
    WHEN mc_wt_message.
      CALL METHOD get_message_quick_info
        EXPORTING
          iv_message    = lv_context_string
        IMPORTING
          ev_quick_info = lv_string.
    WHEN mc_wt_text_element.
      CALL METHOD get_text_element_quick_info
        EXPORTING
          iv_text_elem  = lv_context_string
        IMPORTING
          ev_quick_info = lv_string.
    WHEN 0.
*     Context string should be analyized.
      IF lv_string IS INITIAL.
        CONCATENATE '\bTest :\b0' lv_context_string INTO lv_string
        SEPARATED BY space.
      ENDIF.
    WHEN OTHERS.
  ENDCASE.

* The method should be called even with empty string
  CALL METHOD call_method
    EXPORTING
      method  = 'ShowQuickInfo'
      p1      = lv_string
      p_count = 1
    EXCEPTIONS
      OTHERS  = 1.

  IF sy-subrc <> 0.
    RAISE error.
  ENDIF.

ENDMETHOD.                    "ON_QUICK_INFO
METHOD prepare_class_attributes_list.
  DATA:        lv_pattern       TYPE char255,
                  lv_classname     TYPE seoclskey,
                  lv_cmptype       TYPE seocmptype,
                  lv_attdecltyp    TYPE seoattdecl,
                  ls_list          LIKE LINE OF ct_list.

  FIELD-SYMBOLS: <ls_attributes> LIKE LINE OF gt_attributes.

* Init buffers
  REFRESH gt_attributes.

* Prepare ABAP pattern
  lv_pattern   = iv_pattern.
  lv_classname = iv_parent.
  TRANSLATE lv_pattern USING '%*?+'.

*   Static or instance
  IF iv_data_type EQ mc_wt_attrib_class.
    lv_attdecltyp = 1.
  ENDIF.

* Get methods and attributes for requested class
  CALL FUNCTION 'SEO_CLASS_TYPEINFO_GET'
    EXPORTING
      clskey     = lv_classname
    IMPORTING
      attributes = gt_attributes
    EXCEPTIONS
      OTHERS     = 1.

  IF sy-subrc NE 0.
    RAISE not_found.
  ENDIF.

* Extract inherited methods / attributes / ..
  CALL FUNCTION 'SEO_CLASS_RESOLVE_INHERITANCE'
    EXPORTING
      clskey     = lv_classname
    IMPORTING
      attributes = gt_attributes
    EXCEPTIONS
      OTHERS     = 1.

*-> Komponenten von implementierten Interfaces
  CALL FUNCTION 'SEO_CLASS_RESOLVE_IMPLEMENTGS'
    EXPORTING
      clskey     = lv_classname
    IMPORTING
      attributes = gt_attributes
    EXCEPTIONS
      OTHERS     = 1.

* Komponenten von geerbten Interfaces
  CALL FUNCTION 'SEO_CLASS_RESOLVE_IMPS_BY_INH'
    EXPORTING
      clskey     = lv_classname
    IMPORTING
      attributes = gt_attributes
    EXCEPTIONS
      OTHERS     = 1.

  CHECK ct_list IS SUPPLIED.

  ls_list-data_type  = iv_data_type.
  LOOP AT gt_attributes ASSIGNING <ls_attributes>
  WHERE alias      EQ space AND
        attdecltyp EQ lv_attdecltyp OR
        attdecltyp EQ 2.

*     Filter not requested attributes
    CHECK <ls_attributes>-cmpname CP lv_pattern
      AND sy-fdpos EQ 0.

    IF <ls_attributes>-attdecltyp EQ 2.
      ls_list-image_indx = 7.
    ELSE.
      ls_list-image_indx = 18.
    ENDIF.

    ls_list-text = <ls_attributes>-cmpname.
    TRANSLATE ls_list-text TO LOWER CASE.

    IF <ls_attributes>-clsname EQ lv_classname.
      ls_list-bold       = ctrue.
    ELSE.
      ls_list-bold       = cfalse.
    ENDIF.
    CASE <ls_attributes>-exposure.
      WHEN '0'.
        ls_list-sub_image_indx = 3.
      WHEN '1'.
        ls_list-sub_image_indx = 4.
      WHEN OTHERS.
        ls_list-sub_image_indx = 2.
    ENDCASE.
    appent_list ls_list ct_list..
  ENDLOOP.

ENDMETHOD.                    "prepare_class_attributes_list
METHOD prepare_class_methods_list.
ENDMETHOD.                    "PREPARE_CLASS_METHODS_LIST
METHOD prepare_dict_class_list.
ENDMETHOD.                    "PREPARE_DICT_CLASS_LIST
METHOD prepare_dict_data_elem_list.
ENDMETHOD.                    "PREPARE_DICT_DATA_ELEM_LIST
METHOD prepare_dict_structure_list.
ENDMETHOD.                    "PREPARE_DICT_STRUCTURE_LIST
METHOD prepare_dict_table_type_list.
ENDMETHOD.                    "PREPARE_DICT_TABLE_TYPE_LIST
METHOD prepare_domain_values_list.
ENDMETHOD.                    "PREPARE_DOMAIN_VALUES_LIST
METHOD prepare_dynpro_list.
ENDMETHOD.                    "PREPARE_DYNPRO_LIST
METHOD prepare_function_list.
  DATA:          lt_functions   TYPE TABLE OF rs38l_fnam,
                    ls_list        LIKE LINE OF ct_list.

  FIELD-SYMBOLS: <ls_functions> TYPE rs38l_fnam.

  SELECT funcname FROM tfdir INTO TABLE lt_functions
  WHERE  funcname LIKE iv_pattern.

  ls_list-data_type  = mc_wt_function.
  ls_list-image_indx = 9.
  LOOP AT lt_functions ASSIGNING <ls_functions>.
    ls_list-text       = <ls_functions>.
    appent_list ls_list ct_list..
  ENDLOOP.

ENDMETHOD.                    "prepare_function_list
METHOD prepare_message_list.
ENDMETHOD.                    "PREPARE_MESSAGE_LIST
METHOD prepare_program_index_list.
ENDMETHOD.                    "PREPARE_PROGRAM_INDEX_LIST
METHOD prepare_struct_component_list.
ENDMETHOD.                    "PREPARE_STRUCT_COMPONENT_LIST
METHOD prepare_text_element_list.
  DATA:          lv_pattern       TYPE char255,
                    lv_length        TYPE numc3,
                    ls_list          LIKE LINE OF ct_list.
  FIELD-SYMBOLS: <ls_buffer>      LIKE LINE OF gt_textpool.

*   Clear buffer
  REFRESH gt_textpool.

*   Read textpool
  READ TEXTPOOL gv_main_prog INTO gt_textpool LANGUAGE sy-langu.
  IF sy-subrc NE 0.
    READ TEXTPOOL gv_main_prog INTO gt_textpool LANGUAGE 'E'.
    IF sy-subrc NE 0.
      READ TEXTPOOL gv_main_prog INTO gt_textpool LANGUAGE 'D'.
    ENDIF.
  ENDIF.

  CHECK ct_list IS SUPPLIED.

* Prepare ABAP pattern
  lv_pattern = iv_pattern.
  TRANSLATE lv_pattern USING '%*?+'.

  ls_list-data_type  = mc_wt_text_element.
  ls_list-image_indx = 15.
  LOOP AT gt_textpool ASSIGNING <ls_buffer>
  WHERE id EQ 'I'.

*     Filter not requested text elements
    CHECK <ls_buffer>-key CP lv_pattern
      AND sy-fdpos EQ 0.

    CONCATENATE <ls_buffer>-key ':' <ls_buffer>-entry
    INTO ls_list-text SEPARATED BY space.
    WRITE <ls_buffer>-length TO lv_length.
    CONCATENATE ls_list-text ' (' lv_length ')' INTO ls_list-text.
    appent_list ls_list ct_list..
  ENDLOOP.

ENDMETHOD.                    "prepare_text_element_list
METHOD prepare_transaction_list.
ENDMETHOD.                    "PREPARE_TRANSACTION_LIST
METHOD prepare_type_pool_list.
ENDMETHOD.                    "PREPARE_TYPE_POOL_LIST
METHOD read_report.
  DATA         : ls_sources    LIKE LINE OF gt_sources.
  FIELD-SYMBOLS: <ls_sources>  LIKE LINE OF gt_sources,
                 <ls_report>   LIKE LINE OF et_report.

  REFRESH et_report.

*   Check buffer
  READ TABLE gt_sources WITH KEY include = iv_report_name
  TRANSPORTING NO FIELDS.
  IF sy-subrc EQ 0.
*     Take entries from the buffer
    LOOP AT gt_sources ASSIGNING <ls_sources> FROM sy-tabix.
      APPEND <ls_sources>-line TO et_report.
    ENDLOOP.
  ELSE.
*   Load report
    READ REPORT iv_report_name INTO et_report.
*   Update buffer
    ls_sources-include = iv_report_name.
    LOOP AT et_report ASSIGNING <ls_report>.
      ls_sources-line = <ls_report>.
      APPEND ls_sources TO gt_sources.
    ENDLOOP.
  ENDIF.

ENDMETHOD.                    "read_report
METHOD refresh_buffers.
  CLEAR :   gt_sources,
               gt_breapoints,
               gt_bookmarks,
               gt_protec_lines,
               gt_inc,
               gt_compo,
               gt_cross_ref,
               gv_new_rdire,
               gt_methods,
               gt_attributes,
               gt_nametab.

ENDMETHOD.                    "refresh_buffers
METHOD register_events.
  DATA: ex_event     TYPE cntl_event,  "// eventid, is_shellevent
        events_ex    TYPE cntl_events.    "// table


* check handle
  IF h_control IS INITIAL.
  ENDIF.

  ex_event-is_shellevent    = space.
  ex_event-is_systemevent   = gc_true.
  ex_event-shellid          = h_control-shellid.

* Register events
  ex_event-eventid = event_help.
  APPEND ex_event TO events_ex.
  ex_event-eventid = event_navigate.
  APPEND ex_event TO events_ex.
  ex_event-eventid = event_completion.
  APPEND ex_event TO events_ex.
  ex_event-eventid = event_save.
  APPEND ex_event TO events_ex.
  ex_event-eventid = event_quick_info.
  APPEND ex_event TO events_ex.
  ex_event-eventid = event_insert_pattern.
  APPEND ex_event TO events_ex.

  CALL METHOD set_registered_events_ex
    EXPORTING
      eventtab                  = events_ex
    EXCEPTIONS
      cntl_error                = 1
      cntl_system_error         = 2
      illegal_event_combination = 3
      OTHERS                    = 4.
ENDMETHOD.                    "register_events
METHOD save.
ENDMETHOD.                    "SAVE
METHOD set_bookmarks_as_r3table.
ENDMETHOD.                    "SET_BOOKMARKS_AS_R3TABLE
METHOD set_breakpoints_as_r3table.
ENDMETHOD.                    "SET_BREAKPOINTS_AS_R3TABLE
METHOD set_protected_lines_as_r3table.
ENDMETHOD.                    "SET_PROTECTED_LINES_AS_R3TABLE
METHOD set_readonly_mode.

ENDMETHOD.                    "SET_READONLY_MODE
METHOD set_selected_text_as_r3table.
  TYPES: x256(120) TYPE x.
  DATA: l_table TYPE TABLE OF x256.
  DATA: x_test TYPE xstring.
  DATA: s_test TYPE string.

  FIELD-SYMBOLS: <wa_table> TYPE ANY.
  LOOP AT table ASSIGNING <wa_table>.
    CONCATENATE s_test <wa_table> cl_abap_char_utilities=>cr_lf
                INTO s_test.
  ENDLOOP.

  DATA: encoding                    TYPE abap_encod.
  encoding = 'utf-16le'.
  DATA: codepage            TYPE cpcodepage.

  CALL FUNCTION 'SCP_CODEPAGE_BY_EXTERNAL_NAME'
    EXPORTING
      external_name = encoding
    IMPORTING
      sap_codepage  = codepage
    EXCEPTIONS
      not_found     = 1
      OTHERS        = 2.

  encoding = codepage.
  CALL FUNCTION 'SCMS_STRING_TO_XSTRING'
    EXPORTING
      text     = s_test
      encoding = encoding
    IMPORTING
      buffer   = x_test.
  IF sy-subrc <> 0.
  ENDIF.

  CALL FUNCTION 'SCMS_XSTRING_TO_BINARY'
    EXPORTING
      buffer     = x_test
    TABLES
      binary_tab = l_table.

* create dataprovider object and send data to frontend
  CALL FUNCTION 'DP_CREATE_FROM_STREAM'
    EXPORTING
      type                 = cndp_sap_tab_mimetype
      subtype              = 'ABAP_SOURCE' " cndp_sap_subtype_unknown
*      size                 = len
    TABLES
      data                 = l_table
    CHANGING
      h_dp                 = m_dp_handle
    EXCEPTIONS
      dp_error_general     = 1
      dp_error_create      = 2
      dp_error_send        = 3
      OTHERS               = 4.

ENDMETHOD.                    "SET_SELECTED_TEXT_AS_R3TABLE
METHOD set_text_as_r3table.
*@78\QImporting@	TABLE	TYPE STANDARD TABLE	
*@03\QException@	ERROR_DP		
*   set_table_property table. "'YES_ABAP_EDITOR'.

  TYPES: x256(120) TYPE x.
  DATA: l_table TYPE TABLE OF x256.
  DATA: x_test TYPE xstring.
  DATA: s_test TYPE string.

  FIELD-SYMBOLS: <wa_table> TYPE ANY.
  LOOP AT table ASSIGNING <wa_table>.
    CONCATENATE s_test <wa_table> cl_abap_char_utilities=>cr_lf
                INTO s_test.
  ENDLOOP.

  DATA: encoding                    TYPE abap_encod.
  encoding = 'utf-16le'.
  DATA: codepage            TYPE cpcodepage.

  CALL FUNCTION 'SCP_CODEPAGE_BY_EXTERNAL_NAME'
    EXPORTING
      external_name = encoding
    IMPORTING
      sap_codepage  = codepage
    EXCEPTIONS
      not_found     = 1
      OTHERS        = 2.

  encoding = codepage.
  CALL FUNCTION 'SCMS_STRING_TO_XSTRING'
    EXPORTING
      text     = s_test
      encoding = encoding
    IMPORTING
      buffer   = x_test.
  IF sy-subrc <> 0.
  ENDIF.

  CALL FUNCTION 'SCMS_XSTRING_TO_BINARY'
    EXPORTING
      buffer     = x_test
    TABLES
      binary_tab = l_table.

* create dataprovider object and send data to frontend
  CALL FUNCTION 'DP_CREATE_FROM_STREAM'
    EXPORTING
      type                 = cndp_sap_tab_mimetype
      subtype              = 'ABAP_SOURCE' " cndp_sap_subtype_unknown
*      size                 = len
    TABLES
      data                 = l_table
    CHANGING
      h_dp                 = m_dp_handle
    EXCEPTIONS
      dp_error_general     = 1
      dp_error_create      = 2
      dp_error_send        = 3
      OTHERS               = 4.


*  CALL FUNCTION 'DP_SEND_STREAM'
*      EXPORTING
*        h_dp                 = m_dp_handle
*        type                 = cndp_sap_tab_mimetype
*        subtype              = 'ABAP_SOURCE'
**      description          = &2
**        send_data_as_string  = 'X'
*      TABLES
*        data                 = l_table
*      EXCEPTIONS
*        dp_invalid_parameter = 1
*        dp_create_url        = 2
*        dp_error_call_method = 3
*        OTHERS               = 4.

ENDMETHOD.                    "set_text_as_r3table
METHOD update_display.
ENDMETHOD.                    "UPDATE_DISPLAY
METHOD update_structure.
  DATA:          lt_report    TYPE report_tbl,
                   lt_report2   TYPE report2_tbl,
                   lt_inc       LIKE gt_inc,
                   lt_compo     LIKE gt_compo,
                   lt_cross_ref LIKE gt_cross_ref.

  FIELD-SYMBOLS: <ls_compo> LIKE LINE OF gt_compo.

  CHECK NOT gv_report_name IS INITIAL.

*   Parse main program INITIALy
  IF gt_compo     IS INITIAL AND
     gt_cross_ref IS INITIAL AND
     gt_inc       IS INITIAL.

    CALL FUNCTION 'RS_PROGRAM_INDEX'
      EXPORTING
        pg_name       = gv_main_prog
      IMPORTING
        message_class = gv_new_rdire
      TABLES
        compo         = gt_compo
        cross_ref     = gt_cross_ref
        inc           = gt_inc
      EXCEPTIONS
        OTHERS        = 1.

  ENDIF.

*   Load report
  CALL METHOD get_report
    IMPORTING
      et_report = lt_report.

  CHECK gv_struct_update EQ gc_true.
  gv_struct_update = gc_false.

*   Cast tables
  lt_report2 = lt_report.

* Scan report structure for components
  CALL FUNCTION 'RS_PROGRAM_INDEX_SOURCE'
    EXPORTING
      pg_name     = gv_main_prog
    TABLES
      source_incl = lt_report2
      compo       = lt_compo
      cross_ref   = lt_cross_ref
      inc         = lt_inc
    EXCEPTIONS
      OTHERS      = 1.

* Update buffer
  DELETE gt_compo WHERE incl EQ gv_report_name.
  APPEND LINES OF lt_compo TO gt_compo.
  SORT gt_compo.

ENDMETHOD.                    "update_structure
