CLASS-POOL.
*---------------------------------------------------------------------*
*       CLASS ZCL_ES_OO_DYNPRO_EXAMPLE  DEFINITIO
*---------------------------------------------------------------------*
*
*---------------------------------------------------------------------*
CLASS zcl_es_oo_dynpro_example DEFINITION
  PUBLIC
  INHERITING FROM cl_ctrler_screen_window
  CREATE PUBLIC.

  PUBLIC SECTION.

    EVENTS navigation_requested.

    METHODS constructor.
  PROTECTED SECTION.

    CONSTANTS c_pfstatus_popup TYPE sypfkey VALUE 'POPUP'.  

    METHODS navigate
      FOR EVENT navigation_requested OF zcl_es_oo_dynpro_example.

    METHODS on_call_screen
      REDEFINITION.
    METHODS on_process_fcode
      REDEFINITION.
  PRIVATE SECTION.

    DATA c_pfstatus_window TYPE sypfkey VALUE 'WINDOW'.
    DATA c_repid TYPE syrepid
 VALUE 'SAPLZESU_BC640_OO_DYNPRO_LEG'.
    DATA c_titlebar TYPE gui_title VALUE 'TITLE'.
ENDCLASS.                    "ZCL_ES_OO_DYNPRO_EXAMPLE  DEFINITIO
*---------------------------------------------------------------------*
*                       REDIFINITIONS
*---------------------------------------------------------------------*
*
*                                                                     *
*---------------------------------------------------------------------*
*                       IMPLEMENTATION
*---------------------------------------------------------------------*
*
*                                                                     *
METHOD constructor.


  super->constructor( ).

  repid = c_repid.
  dynnr = '0100'.

  DATA: l_pfstatus TYPE sypfkey.

  CASE popup.
    WHEN space.
      l_pfstatus = c_pfstatus_window.
    WHEN OTHERS.
      l_pfstatus = c_pfstatus_popup.
  ENDCASE.

  r_status->set_pfstatus(
    pfstatus       = l_pfstatus
    pfstatus_repid = me->c_repid ).

  SET HANDLER navigate FOR me.

ENDMETHOD.                    "constructor
METHOD navigate.
  IF dynnr = '0100'.
    dynnr = '0200'.
  ELSE.
    dynnr = '0100'.
  ENDIF.
  CLEAR r_screen.

  me->display( ).
  set_fcode_handled( ).

ENDMETHOD.                    "NAVIGATE
METHOD on_call_screen.

  CALL FUNCTION 'Z_DYNPRO_CALL_SCREEN'
    EXPORTING
      i_dynnr      = dynnr
      i_popup      = popup
      i_starting_x = starting_x
      i_ending_x   = ending_x
      i_starting_y = starting_y
      i_ending_y   = ending_y.

ENDMETHOD.                    "on_call_screen
METHOD on_process_fcode.
  super->on_process_fcode( fcode ).

  IF r_status->pfstatus_repid EQ c_repid AND
     ( r_status->pfstatus EQ c_pfstatus_window OR
       r_status->pfstatus EQ c_pfstatus_popup ).
    CASE fcode.
      WHEN 'BACK' OR 'CANC' OR 'OK'.
        SET SCREEN 0.
        LEAVE SCREEN.
        set_fcode_handled( ).

      WHEN 'EXIT'.
        LEAVE PROGRAM.

      WHEN 'PRESS_ME'.
        RAISE EVENT navigation_requested.

      WHEN 'HI'.
        MESSAGE 'OO Event Handler! Yay!' TYPE 'I'.
        set_fcode_handled( ).

      WHEN OTHERS.
        RAISE EVENT handle_fcode EXPORTING fcode = fcode.
    ENDCASE.
  ENDIF.

ENDMETHOD.                    "on_process_fcode
