************************************************************************
* Program Name: KEG Shared Macros                 Creation: 12/03/2001
*
*                                                                      *
* SAP Name    : ZESI_KEG_MACROS                   Application: U       *
*                                                                      *
* Author      : Thomas Jung                       Type: I              *
*______________________________________________________________________*
* Description : This include contains reusable Macros to assist
* in programming tasks.
*______________________________________________________________________*
* Inputs:                                                              *
*                                                                      *
* Outputs:                                                             *
*______________________________________________________________________*
* External Routines
*
* Classes:
*
* Function Modules:
*
* Programs:
*______________________________________________________________________*
* Return Codes:
*______________________________________________________________________*
* Ammendments:                                                         *
*    Programmer        Date     Req. #            Action               *
* ================  ==========  ======  ===============================*
* Thomas Jung       12/03/2001  ------  Initial Program.               *
*                                                                      *
************************************************************************
  data: percent_tmp type p.
  data: percent type i.
  data: gui_text like sy-ucomm.
  data: total_p(6) type c.
  data: total_e(6) type c.

  define clear_itab.
****Clear the header area the data area of an Internal Table
    clear &1.
    refresh &1.
  end-of-definition.

  define destroy_control.
****Destroys a control on the Frontend and in the Control Framework
****And destroys the pointer to the object.
    if &1 is initial.
    else.
      call method &1->free.
      clear &1.
    endif.
  end-of-definition.

  define gui_progress.
*&1 - Number Processed
*&2 - Number Total
*&3 - Text



    move &1 to total_p.
    move &2 to total_e.

    if &2 = 0.
      move &3 to gui_text.
    else.
      concatenate total_p
                  '/'
                  total_e
                  &3
                  into gui_text
                  separated by space.
    endif.

    if &2 ne 0.
      percent_tmp = ( &1 / &2 ) * 100.
    else.
      move 0 to percent_tmp.
    endif.

    move percent_tmp to percent.

    call function 'SAPGUI_PROGRESS_INDICATOR'
         exporting
              percentage = percent
              text       = gui_text.

  end-of-definition.
